<?php 
class WCPS_OptionsMenu
{

	function __construct() 
	{
	}
	public function render_page()
	{
		global $wcps_option_model,$wcps_order_model;
		$time_offset = $wcps_option_model->get_option('time_offset');
		$old_variable_product_show_price_method = $wcps_option_model->get_option('old_variable_product_show_price_method');
		$show_sale_badge = $wcps_option_model->get_option('show_sale_badge');
		$coupon_code_can_be_used_when_item_is_in_presale = $wcps_option_model->get_option('coupon_code_can_be_used_when_item_is_in_presale');
		$disable_tax_application = $wcps_option_model->get_option('disable_tax_application');
		$expired_product_still_visible = $wcps_option_model->get_option('expired_product_still_visible');
		$date_format = $wcps_option_model->get_option('date_format');
		$enable_sale_products = $wcps_option_model->get_option('enable_sale_products');
		$timer_disable_week_counter = $wcps_option_model->get_option('timer_disable_week_counter');
		//$timer_disable_day_counter = $wcps_option_model->get_option('timer_disable_day_counter');
		//$timer_disable_hour_counter = $wcps_option_model->get_option('timer_disable_hour_counter');
		$timer_disable_minute_counter = $wcps_option_model->get_option('timer_disable_minute_counter');
		$timer_disable_second_counter = $wcps_option_model->get_option('timer_disable_second_counter');
		$product_page_infos_display_position = $wcps_option_model->get_option('product_page_infos_display_position');
		$order_status_to_assign_after_checkout = $wcps_option_model->get_option('order_status_to_assign_after_checkout');
		$default_sale_badge_text = $wcps_option_model->get_option('default_sale_badge_text');
		$badge_text_next_to_product = $wcps_option_model->get_option('badge_text_next_to_product');
		//$post_types = get_post_types();
		//wcps_var_dump($order_status_to_assign_after_checkout);
		
		wp_enqueue_style('wcps-options-menu', WCPS_PLUGIN_PATH.'/css/wcps-admin-option-menu.css');
		?>
		<div id="icon-themes" class="icon32"><br></div>
		
		<div class="wrap">
			<h2><?php _e('Pre-sales options', 'woocommerce-pre-sale');?></h2>
			<div id="white-box">
				<form action="options.php" method="post"  >
				<?php settings_fields('wcps_options_group'); ?> 
				
				
				<h4 class="wccm_no_margin_top"><?php _e('Time offset', 'woocommerce-pre-sale');?></h4>
				<p><?php _e('Expiring date is set using server time. Current server time is: ', 'woocommerce-pre-sale'); ?>
				<strong><?php echo date("l").", ".date("H:i"); ?></strong></p>
				<p><?php _e('Current server time with offset is: ', 'woocommerce-pre-sale'); ?>
				<strong><?php echo date("l", strtotime($time_offset.' minutes')).", ".date("H:i", strtotime($time_offset.' minutes')); ?></strong></p>
				<strong><?php  _e('NOTE:', 'woocommerce-pre-sale'); ?></strong> <?php  _e('Offset value is expressed in minutes. So if you want to add one hour, set it to 60', 'woocommerce-pre-sale'); ?> <br/>
				<input type="number" name="wcps_options[time_offset]" min="-1440" max="1440" value="<?php echo $time_offset; ?>"></input>
				
				<h4><?php _e('Date format', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('Select which date format has to be used to display <i>current server time</i> and <i>start/end expirng date</i> in product edit page.', 'woocommerce-pre-sale'); ?></p>
				<select name="wcps_options[date_format]">
					<option value="yyyy/mm/dd" <?php if($date_format == 'yyyy/mm/dd') echo 'selected="selected"';?>>yyyy/mm/dd</option>
					<option value="dd/mm/yyyy" <?php if($date_format == 'dd/mm/yyyy') echo 'selected="selected"';?>>dd/mm/yyyy</option>
				</select>
				
				<h4><?php _e('Variable product price display', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('Display price as <strong><i>From {min_price}€</i></strong> instead of <strong><i>{min_price}€ - {max_price}€</i></strong> during a pre-sale/time offer periods.', 'woocommerce-pre-sale'); ?></p>
				<input type="checkbox" name="wcps_options[old_variable_product_show_price_method]" value="true" <?php if(isset($old_variable_product_show_price_method)) echo 'checked="checked"'; ?>></input>	
					
				<h4><?php _e('Enable display pre-sale/time period offer products among sale products', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('By default pre-sale/time period offer products are not listed among sale products (for example the ones listed used the [sale_products] shortcode). You can enable this feature by checking the following checkbox.', 'woocommerce-pre-sale'); ?></p>
				<p><?php _e('<strong>NOTE:</strong> <i>This may cause slow page loading time on pages where widget/shortcodes to list product are used. If you are expiriencing this kind of issue keem this option disabled.</i>', 'woocommerce-pre-sale'); ?></p>
				<input type="checkbox" name="wcps_options[enable_sale_products]" value="true" <?php if($enable_sale_products) echo 'checked="checked"'; ?>></input>	
						
				<h4><?php _e('Sale badge', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('Display sale badge for product which the pre-sale/time offer period price is lower than the regular one', 'woocommerce-pre-sale'); ?></p>
				<input type="checkbox" name="wcps_options[show_sale_badge]" value="true" <?php if(isset($show_sale_badge)) echo 'checked="checked"'; ?>></input>	
				
				<h4><?php _e('Sale badge - default  text override', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('In case the "Sale badge" option has been enabled, the default WooCommerce "Sale" text badge can be customized using the following text input. <strong>Note</strong> that Text badge can be customized specifically for each product via its edit page (or bulk editor). Leave empty for defaults WooCommerce value.', 'woocommerce-pre-sale'); ?></p>
				<input type="text" name="wcps_options[default_sale_badge_text]" value="<?php echo $default_sale_badge_text; ?>" placeholder="<?php _e('Sale','woocommerce-pre-sale'); ?>"></input>

				<h4><?php _e('Products table - text badge to show nex to item(s) in pre-sale on the products table in Cart, Checkout, Order details pages and Emails', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('On products table showed on Cart, Checkout, Order details pages and Emails, for each item that is on Pre-sale/Time offer period, can be showed a badge text next to them. Use the following text area to input the text that has to be showed. Text badge can be customized specifically for each product via its edit page (or bulk editor). Leave empty to not show anything.', 'woocommerce-pre-sale'); ?></p>
				<input type="text" name="wcps_options[badge_text_next_to_product]" value="<?php echo $badge_text_next_to_product; ?>" placeholder="<?php _e('(Pre-sale)','woocommerce-pre-sale'); ?>"></input>					
					
				<h4><?php _e('Product page - infos display position (timer, progress bar, expiration message, ...)', 'woocommerce-pre-sale');?></h4>	
				<select name="wcps_options[product_page_infos_display_position]">
					<option value="woocommerce_single_product_summary" <?php if($product_page_infos_display_position == 'woocommerce_single_product_summary') echo 'selected="selected"';?>><?php _e('After product title', 'woocommerce-pre-sale') ?></option>
					<option value="woocommerce_before_single_product_summary" <?php if($product_page_infos_display_position == 'woocommerce_before_single_product_summary') echo 'selected="selected"';?>><?php _e('Before product picture(s)', 'woocommerce-pre-sale') ?></option>
					<option value="woocommerce_after_single_product_summary" <?php if($product_page_infos_display_position == 'woocommerce_after_single_product_summary') echo 'selected="selected"';?>><?php _e('After product picture(s)', 'woocommerce-pre-sale') ?></option>
					<option value="woocommerce_before_add_to_cart_form" <?php if($product_page_infos_display_position == 'woocommerce_before_add_to_cart_form') echo 'selected="selected"';?>><?php _e('Before add to cart button', 'woocommerce-pre-sale') ?></option>
					<option value="woocommerce_after_add_to_cart_form" <?php if($product_page_infos_display_position == 'woocommerce_after_add_to_cart_form') echo 'selected="selected"';?>><?php _e('After add to cart button', 'woocommerce-pre-sale') ?></option>
					<option value="woocommerce_after_single_product" <?php if($product_page_infos_display_position == 'woocommerce_after_single_product') echo 'selected="selected"';?>><?php _e('At page bottom (after all product infos)', 'woocommerce-pre-sale') ?></option> 
				</select>
				
				<h4><?php _e('Timer - Disable counters', 'woocommerce-pre-sale');?></h4>	
				<h5><?php _e('Disable Week counter', 'woocommerce-pre-sale');?></h5>
				<p><?php _e('By default the timer displayed on Shop and Product pages, in case the time left is bigger that 7 days, adds also a week counter. You can disable it, in this way the timer will show the time left using days, hours, minutes and seconds.', 'woocommerce-pre-sale'); ?></p>
				<select name="wcps_options[timer_disable_week_counter]">
					<option value="no" <?php if($timer_disable_week_counter == 'no') echo 'selected="selected"';?>><?php _e('No', 'woocommerce-pre-sale');?></option>
					<option value="yes" <?php if($timer_disable_week_counter == 'yes') echo 'selected="selected"';?>><?php _e('Yes', 'woocommerce-pre-sale');?></option>
				</select>
				<h5><?php _e('Disable Minute counter', 'woocommerce-pre-sale');?></h5>
				<select name="wcps_options[timer_disable_minute_counter]">
					<option value="no" <?php if($timer_disable_minute_counter == 'no') echo 'selected="selected"';?>><?php _e('No', 'woocommerce-pre-sale');?></option>
					<option value="yes" <?php if($timer_disable_minute_counter == 'yes') echo 'selected="selected"';?>><?php _e('Yes', 'woocommerce-pre-sale');?></option>
				</select>
				<h5><?php _e('Disable Second counter', 'woocommerce-pre-sale');?></h5>
				<select name="wcps_options[timer_disable_second_counter]">
					<option value="no" <?php if($timer_disable_second_counter == 'no') echo 'selected="selected"';?>><?php _e('No', 'woocommerce-pre-sale');?></option>
					<option value="yes" <?php if($timer_disable_second_counter == 'yes') echo 'selected="selected"';?>><?php _e('Yes', 'woocommerce-pre-sale');?></option>
				</select>
				
				<h4><?php _e('Expired product managment', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('By default expired product are set as <strong>Draft</strong>. Enablig the following option products will be still <strong>visible</strong> but unpurchasable.', 'woocommerce-pre-sale'); ?></p>
				<p><?php _e('Enabling the following option will also add additional text fields to display shop and product pages message after the product will expire. Go to product edit page and the in the "Pre-sale" tab to set those texts.', 'woocommerce-pre-sale'); ?></p>
				<input type="checkbox" name="wcps_options[expired_product_still_visible]" value="true" <?php if($expired_product_still_visible) echo 'checked="checked"'; ?>></input>	
				
				<h4><?php _e('Checkout order status - assign a custom order status to orders containing at least a Pre-sale/Time offer product', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('Select which status assign after an order containing at least Pre-sale/Time offer product. Order status can be added and managed using 3rd party plugins.', 'woocommerce-pre-sale'); ?></p>
				<select name="wcps_options[order_status_to_assign_after_checkout]">
					<option value="leave_default" <?php if($order_status_to_assign_after_checkout == 'leave_default') echo 'selected="selected"';?>><?php _e('Default status assigned by WooCommerce', 'woocommerce-pre-sale') ?></option>
					<?php 
						$statuses = $wcps_order_model->get_order_statuses();
						foreach($statuses['statuses'] as $order_status_code => $order_status_name)
						{
							$selected = $order_status_to_assign_after_checkout == $order_status_code ? 'selected="selected"' : "";
							echo '<option value="'.$order_status_code.'" '.$selected.' >'.$order_status_name.'</option>';
						}
					?>
				</select>
				
				<h4><?php _e('Coupon usage while products are in pre-order/pre-sale state', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('By default coupon codes cannot be used while a product is in a pre-order/pre-sale state. Enable this option to allow your customers to use coupon codes even if the item is still in pre-order/pre-sale state.', 'woocommerce-pre-sale'); ?></p>
				<input type="checkbox" name="wcps_options[coupon_code_can_be_used_when_item_is_in_presale]" value="true" <?php if($coupon_code_can_be_used_when_item_is_in_presale) echo 'checked="checked"'; ?>></input>	
				
				<h4><?php _e('Disable tax', 'woocommerce-pre-sale');?></h4>	
				<p><?php _e('By default the plugin applies taxes to products according the WooCommerce -> Tax setting. Enable this option to completely disable tax application.', 'woocommerce-pre-sale'); ?></p>
				<input type="checkbox" name="wcps_options[disable_tax_application]" value="true" <?php if($disable_tax_application) echo 'checked="checked"'; ?>></input>	
				
				<p class="submit">
					<input name="Submit" type="submit" class="button-primary" id="save-button" value="<?php esc_attr_e('Save', 'woocommerce-pre-sale'); ?>" />
				</p>
				</form>
			</div>
		</div>
		<?php
		
	}	
		
}
?>