<?php 
class WCPS_ProductDetails
{
	public function __construct()
	{
		try{
			$wc_version = wcps_get_woo_version_number();
		}catch(Exception $e){}
		
		
		add_action('woocommerce_product_write_panel_tabs', array( &$this,'add_presale_tab') );
		if(!isset($wc_version) || version_compare($wc_version , 2.7, '<')  )
			add_action('woocommerce_product_write_panels', array( &$this,'add_presale_tab_options') ); 
		else 
			add_action('woocommerce_product_data_panels', array( &$this,'add_presale_tab_options') );
			
		add_action( 'add_meta_boxes', array( &$this, 'add_presale_metabox' ) );
		//add_action('admin_init', array(&$this, 'admin_init'));
		add_action( 'woocommerce_process_product_meta',  array( &$this, 'presale_data_save') );
		//add_filter( 'product_type_options', array( &$this,'add_presale_option' ));
	}
	public function add_presale_metabox()
	{
		add_meta_box( 'woocommerce-pre-sale-total-sales', __('Total purchases during pre-sale / time offer period', 'woocommerce-pre-sale'), array( &$this, 'rendere_presale_metabox' ), 'product', 'side', 'high');
		add_meta_box( 'woocommerce-pre-sale-who-bought', __('Who bought during pre-sale / time offer period?', 'woocommerce-pre-sale'), array( &$this, 'render_who_bought_metabox' ), 'product', 'normal', 'high');
	}
	public function rendere_presale_metabox($product)
	{
		global $wcps_html_helper;
		$wcps_html_helper->woocommerce_total_presales_meta_box($product); 
	} 
	public function render_who_bought_metabox($product)
	{
		global $wcps_html_helper;
		$wcps_html_helper->woocommerce_render_who_bought_metabox($product); 
	}
	
	function add_presale_option($product_type_options)
	{
		 // $product_type_options['virtual']['default'] = 'yes';
		 // $product_type_options['downloadable']['default'] = 'yes';
		 
		 $product_type_options['presale'] = array(
				'id'            => '_presale', // --> name: wcps_data[presale_active]
				'wrapper_class' => 'show_if_simple',
				'label'         => __( 'Presale', 'woocommerce' ),
				'description'   => __( 'Tick to enable presale managment system.', 'woocommerce-pre-sale' ),
				'default'       => 'no'
			);
		 return $product_type_options;
	}
	function add_presale_tab() 
	{
	?>
		<li class="wcps_presale"><a href="#wcps_presale"><?php _e('Pre-sale / Time offer', 'woocommerce-pre-sale'); ?></a></li>
	<?php
	}
	function admin_init()
	{
		if(version_compare( WC_VERSION, '2.7', '<' ))
			add_action('woocommerce_product_write_panels', array( &$this,'add_presale_tab_options') ); 
		else
			add_action('woocommerce_product_data_panels ', array( &$this,'add_presale_tab_options') );
	}
	function add_presale_tab_options() 
	{
		global $post, $wcps_html_helper;
		$wcps_html_helper->woocommerce_product_tab($post); 
	}
	function presale_data_save( $post_id )
	{
		if(is_admin())
		{
			global $wcps_product_model, $wcps_customer_model;
			
			/* Format:
				string(3) "yes"  -> $_POST['wcps_reset_total_presales']

				string(1) "0" -> $_POST['wcps_total_presales']

				array(2) {    ->  $_POST['wcps_reset_user_counter']
				  [15847]=>
				  string(3) "yes"
				  [15869]=>
				  string(3) "yes"
				}
				*/			
			if(isset($_POST['wcps_reset_user_counter']))
			{
				//$total_presales = 0;
				//user update
				foreach( $_POST['wcps_reset_user_counter'] as $user_id => $result)
				{
					if($result == 'yes')
						$wcps_customer_model->update_presale_meta_info($user_id, $post_id, 0, true);
					//$total_presales += $quantity;
				}
				
				//product total presales
				
			}
			if(isset($_POST['wcps_reset_total_presales']) && $_POST['wcps_reset_total_presales'] == 'yes')
				$wcps_product_model->update_total_presales($post_id,0, true);
			
			
			//if(isset($_POST['wcps_data']))
			/* $active = isset($_POST['wcps_data']['presale_active']) ? 'yes':'no';
			$wcps_product_model->save_option( $post_id, 'wcps_data', $_POST['wcps_data']);
			$wcps_product_model->save_option( $post_id, 'wcps_presale_active', $active);
			//Message are stored in separated meta values due to WPML compability
			$wcps_product_model->save_option( $post_id, 'wcps_shop_page_message', $_POST['wcps_shop_page_message']); 
			$wcps_product_model->save_option( $post_id, 'wcps_product_page_message', $_POST['wcps_product_page_message']);		
			$wcps_product_model->save_option( $post_id, 'wcps_add_to_cart_text', $_POST['wcps_add_to_cart_text']);	 */	
			$wcps_product_model->save_all_options( $post_id, $_POST);
		}	 
	}
	
}
?>
