<?php
class WCPS_ProductsTable
{
	public function __construct()
	{
		add_action( 'manage_product_posts_custom_column', array($this, 'manage_presale_column_content'), 10, 2 );
		add_filter( 'manage_edit-product_columns', array($this, 'add_presale_column_head'),15 ); 
		add_action('restrict_manage_posts', array( &$this,'add_presale_and_expired_select_boxes_filter'));
		add_filter('parse_query',array( &$this,'filter_query_by_presale_or_expired_value'));
	}
	
	public function add_presale_column_head($columns)
	 {
		
	   //remove column
	   //unset( $columns['tags'] );

	   //add column
	   $columns['wpcs-presale'] = __('Pre-sale / Time offer', 'woocommerce-pre-sale'); 
	   $columns['wpcs-expired'] = __('Expired', 'woocommerce-pre-sale'); 
	
	   return $columns;
	}
	public function manage_presale_column_content( $column, $product_id ) 
	{
		global $wcps_product_model;
		if ( $column == 'wpcs-presale' ) 
		{
			/* $attachmented_files = get_post_meta($orderid, '_wcam_attachments_meta');
			if(!$attachmented_files || empty($attachmented_files[0]))
				echo "0"; */
			if($wcps_product_model->is_presale_active($product_id))
				echo  __('Yes', 'woocommerce-pre-sale');
			else
				echo  __('No', 'woocommerce-pre-sale');

		}
		if( $column == 'wpcs-expired')
		{
			if($wcps_product_model->is_expired($product_id))
				echo  __('Yes', 'woocommerce-pre-sale');
			else
				echo  __('No', 'woocommerce-pre-sale');
		}
	}
	public function add_presale_and_expired_select_boxes_filter()
	{
		global $typenow;
		global $wp_query;
		if ($typenow=='product') 
		{
			$selected = isset($_GET['wcps_filter_by_presale']) && $_GET['wcps_filter_by_presale'] ? $_GET['wcps_filter_by_presale']:"none";
			$selected2 = isset($_GET['wcps_filter_by_expired_value']) && $_GET['wcps_filter_by_expired_value'] ? $_GET['wcps_filter_by_expired_value']:"none";
			//onchange="this.form.submit()" 
			?>
			<select name="wcps_filter_by_presale" >
				<option value="all" <?php if($selected == "all") echo 'selected="selected"';?>><?php _e('Show all products', 'woocommerce-pre-sale') ?></option>
				<option value="presale-only" <?php if($selected == "presale-only") echo 'selected="selected"';?>><?php _e('with pres-sale / time offer', 'woocommerce-pre-sale') ?></option>
			</select>
			<select name="wcps_filter_by_expired_value" >
				<option value="all" <?php if($selected2 == "all") echo 'selected="selected"';?>><?php _e('Show all products', 'woocommerce-pre-sale') ?></option>
				<option value="expired" <?php if($selected2 == "expired") echo 'selected="selected"';?>><?php _e('Expired products', 'woocommerce-pre-sale') ?></option>
				<option value="not_expired" <?php if($selected2 == "not_expired") echo 'selected="selected"';?>><?php _e('Not expired products', 'woocommerce-pre-sale') ?></option>
			</select>
			<?php
		}
	}
	public function filter_query_by_presale_or_expired_value($query) 
	{
		global $pagenow;
		$qv = &$query->query_vars;
		if ($pagenow=='edit.php' && 
		    isset($qv['post_type']) && $qv['post_type']=='product' && isset($_GET['wcps_filter_by_presale']) && $_GET['wcps_filter_by_presale'] == 'presale-only') 
			{
				 $qv['meta_query'][] = 
					array(
					'key' => 'wcps_presale_active',
					'value' => 'yes'
					/*'compare' => 'NOT NULL',
					 'type' => 'CHAR'  */
				  );
			}
		elseif ( $pagenow=='edit.php' &&
			isset($qv['post_type']) && $qv['post_type']=='product' && isset($_GET['wcps_filter_by_expired_value']) && $_GET['wcps_filter_by_expired_value'] != '' && $_GET['wcps_filter_by_expired_value'] != 'all') 
		{
			/* $query->query_vars['meta_key'] = 'wcps_is_expired';
			$query->query_vars['meta_value'] = $_GET['WCPS_EXPIRED_FILTER_VALUE'] == 'expired' ? false : true; */
			if($_GET['wcps_filter_by_expired_value'] == 'expired')
				$qv['meta_query'][] = 
						array(
								'key' => 'wcps_is_expired',
								'value' => 1
							  );
			else
				$qv['meta_query'][] = 
					 array(
							'relation' => 'OR',
							 array(
								'key' => 'wcps_is_expired',
								'value' => 0
							  ),
							  array(
								'key' => 'wcps_is_expired',
								'compare' => 'NOT EXISTS' 
							  )
						);
		}
		
	}
	
}
?>