<?php 
class WCPS_Cart
{
	public function __construct()
	{
	}
	function set_item_data( $cart_item_key, $key, $value ) 
	{
		$data = (array)WC()->session->get( '_wpcs_product_data' );
		if ( empty( $data[$cart_item_key] ) ) 
		{
			$data[$cart_item_key] = array();
		}
		$data[$cart_item_key][$key] = $value;
		WC()->session->set( '_wpcs_product_data', $data );
	}
	
	function get_item_data( $cart_item_key, $key = null, $default = null ) 
	{
		$data = (array)WC()->session->get( '_wpcs_product_data' );
		if ( empty( $data[$cart_item_key] ) ) {
			$data[$cart_item_key] = array();
		}
		// If no key specified, return an array of all results.
		if ( $key == null ) {
			return $data[$cart_item_key] ? $data[$cart_item_key] : $default;
		}else{
			return empty( $data[$cart_item_key][$key] ) ? $default : $data[$cart_item_key][$key];
		}
	}
	
	function remove_item_data( $cart_item_key = null, $key = null ) 
	{
		$data = (array)WC()->session->get( '_wpcs_product_data' );
		// If no item is specified, delete *all* item data. This happens when we clear the cart (eg, completed checkout)
		if ( $cart_item_key == null ) {
			WC()->session->set( '_wpcs_product_data', array() );
			return;
		}
		// If item is specified, but no data exists, just return
		if ( !isset( $data[$cart_item_key] ) ) {
			return;
		}
		if ( $key == null ) {
			// No key specified, delete this item data entirely
			unset( $data[$cart_item_key] );
		}else{
			if ( isset( $data[$cart_item_key][$key] ) ) {
				unset( $data[$cart_item_key][$key] );
			}
		}
		WC()->session->set( '_wpcs_product_data', $data );
	}
}
?>