<?php 
class WCPS_Order
{
	var $start_date;
	var $end_date;
	var $min_amount;
	var $max_amount;
	var $min_amount_total;
	var $max_amount_total;
	var $statuses;
	var $per_page;
	var $page_num;
	var $customer_ids;
	var $product_ids;
	var $category_ids;
	var $columns_to_export;
	var $customer_relationship;	
	var $product_relationship;	
	var $product_category_relationship;	
	var $product_category_filters_relationship;	
	var $customer_product_category_filters_relationship;	
	var $csv_separator;
	var $total_amount_spent_filter;
	public function __construct()
	{
		if(is_admin())
		{
			add_action('wp_ajax_wcps_get_orders_data', array(&$this, 'ajax_get_orders'));
			add_action('wp_ajax_wcps_get_orders_tot_num', array(&$this, 'ajax_get_tot_orders_num'));
			
			//Custom status
			//add_action( 'init', array(&$this,'add_new_custom_statuses'));
			//add_filter( 'wc_order_statuses', array(&$this,'add_new_custom_statuses_to_order_statuses' ));
		}
	}
	function add_new_custom_statuses() 
	{
		register_post_status( 'wc-wcps-presale', array(
			'label'                     => __('Pre-sale / Time offer', 'woocommerce-pre-sale'),
			'public'                    => true,
			'exclude_from_search'       => false,
			'show_in_admin_all_list'    => true,
			'show_in_admin_status_list' => true,
			'label_count'               => _n_noop( 'Pre-sale / Time offer <span class="count">(%s)</span>', 'Pre-sale / Time offer <span class="count">(%s)</span>' )
		) );
	}
	function add_new_custom_statuses_to_order_statuses( $order_statuses ) 
	{

		$new_order_statuses = array();

		// add new order status after processing
		foreach ( $order_statuses as $key => $status ) {

		    //inserted before "processing" status
			if ( 'wc-processing' === $key ) 
					$new_order_statuses['wc-wcps-presale'] = 'Pre-sale / Time offer';
				
			$new_order_statuses[ $key ] = $status;
		}

		return $new_order_statuses;
	}

	public function add_presale_meta_infos($order_id, $product_ids/* $product_id, $variation_id,  $quantity*/)
	{
		/* $name = "wcps_item-".$product_id;
		if(isset($variation_id) && $variation_id != '')
			$name.= "-".$variation_id; //0 for no variation
		
		update_post_meta($order_id, $name, $quantity); */
		if(!isset($product_ids) || empty($product_ids))
			return;
		
		$product_string = implode("-", $product_ids);
		update_post_meta($order_id, "wcps_items", $product_string);
	}
	public function get_presales_items_still_active_num($order_id)
	{
		global $wcps_product_model;
		$order = new WC_Order($order_id);
		$tot_item = 0;
		foreach((array)$order->get_items() as $order_item)
		{
			//wcps_var_dump($order_item["item_meta"]["_product_id"][0]); //["_variation_id"]
			//wcps_var_dump($wcps_product_model->is_presale_active($order_item["item_meta"]["_product_id"][0]));
			$presale_meta = version_compare( WC_VERSION, '2.7', '<' ) ? $order_item["item_meta"]["_product_id"][0] : $order_item->get_product_id();
			if($wcps_product_model->is_presale_active($presale_meta) )
			{
				$tot_item++;
			}
		}
		return $tot_item;
	}
	public function get_presales_items_num($order_id)
	{
		global $wpdb;
		$query =  "SELECT meta_value
				 FROM {$wpdb->postmeta} AS ordermeta
				 WHERE ordermeta.post_id = {$order_id}
				 AND meta_key LIKE 'wcps_items' ";
				 
		$result = $wpdb->get_col($query);
		$result = isset($result) && isset($result[0]) ? $result[0] : false;
		
		if($result != false)
			$result = explode("-",$result);
		else
			$result = array();
		
		return count($result);
	}
	public function get_orders_with_presales_items()
	{
		global $wpdb;
		/* $query =  "SELECT GROUP_CONCAT(post_id) as orders_ids
				 FROM {$wpdb->postmeta}  AS ordermeta
				 WHERE meta_key LIKE '%wcps_item-%' "; */
		$query =  "SELECT GROUP_CONCAT(post_id) as orders_ids
				 FROM {$wpdb->postmeta}  AS ordermeta
				 WHERE meta_key = 'wcps_items' ";
				 
		$result = $wpdb->get_results($query);
		$result = isset($result) && isset($result[0]) ? $result[0] : false;
		return $result;
	}
	public function get_order_statuses()
	{
		$result = array();
		if(function_exists( 'wc_get_order_statuses' ))
		{
			
			$result['version'] = 2.2;
			//[slug] => name
			$result['statuses'] = wc_get_order_statuses();
		}
		else
		{
			$args = array(
				'hide_empty'   => false, 
				'fields'            => 'id=>name', 
			);
			$result['version'] = 2.1;
			//[id] => name
			$result['statuses'] =  get_terms('shop_order_status', $args);
		}
		return $result;
	}
	private function get_request_parameters()
	{
		$this->start_date = isset($_POST['start_date']) ? $_POST['start_date']." 00:00:01": null;
		$this->end_date = isset($_POST['end_date']) ? $_POST['end_date']." 23:59:59": null;
		$this->min_amount = isset($_POST['min_amount']) ? $_POST['min_amount']: null;
		$this->max_amount = isset($_POST['max_amount']) ? $_POST['max_amount']: null;
		$this->min_amount_total = isset($_POST['min_amount_total']) ? $_POST['min_amount_total']: null;
		$this->max_amount_total = isset($_POST['max_amount_total']) ? $_POST['max_amount_total']: null;
		$this->statuses = isset($_POST['statuses']) ? explode(",",$_POST['statuses']): null;	
		$this->per_page = isset($_POST['per_page']) ? $_POST['per_page']: null;	
		$this->page_num = isset($_POST['page_num']) ? $_POST['page_num']: null;	
		$this->customer_ids = isset($_POST['customer_ids']) ? explode(",",$_POST['customer_ids']): null;	
		$this->product_ids = isset($_POST['product_ids']) ? explode(",",$_POST['product_ids']): null;	
		$this->category_ids = isset($_POST['category_ids']) ? explode(",",$_POST['category_ids']): null;
		$this->columns_to_export = isset($_POST['columns_to_export']) ? explode(",",$_POST['columns_to_export']): null;
		$this->customer_relationship = isset($_POST['customer_relationship']) ? $_POST['customer_relationship']: null;	
		$this->product_relationship = isset($_POST['product_relationship']) ? $_POST['product_relationship']: null;	
		$this->product_category_relationship = isset($_POST['product_category_relationship']) ? $_POST['product_category_relationship']: null;	
		$this->product_category_filters_relationship = isset($_POST['product_category_filters_relationship']) ? $_POST['product_category_filters_relationship']: null;	
		$this->customer_product_category_filters_relationship = isset($_POST['customer_product_category_filters_relationship']) ? $_POST['customer_product_category_filters_relationship']: null;	
		$this->csv_separator = isset($_POST['csv_separator']) ? $_POST['csv_separator']: null;	
		$this->total_amount_spent_filter = isset($_POST['total_amount_spent_filter']) ? (bool)$_POST['total_amount_spent_filter']: false;	
	}
	public function ajax_get_orders()
	{
		$orders_array = array();
		$this->get_request_parameters();
		//product and product categories ----> WPML
		$orders = $this->get_order_ids(false);
		
		//$this->var_debug($orders);
		foreach($orders as $order)
		{
			$order_temp = array();
			$order_temp['id'] = $order->id; //0
			$order_temp['order_date'] = $order->order_date;
			
			$bad_char = array('"', "'", ",");
			$order_temp['billing_first_name'] = str_replace( $bad_char, "", $order->billing_first_name);
			$order_temp['billing_last_name'] = str_replace($bad_char, "", $order->billing_last_name);
			$order_temp['billing_email'] = $order->billing_email;	
			/* $order_temp['billing_address_1'] = str_replace($bad_char,"",$order->billing_address_1);
			$order_temp['billing_address_2'] =str_replace($bad_char, "",$order->billing_address_2);
			$order_temp['billing_city'] = str_replace($bad_char,"",$order->billing_city);
			$order_temp['billing_company'] = str_replace($bad_char,"",$order->billing_company);
			$order_temp['billing_country'] = str_replace($bad_char,"",$order->billing_country);		
			$order_temp['billing_phone'] = $order->billing_phone;
			$order_temp['billing_postcode'] = $order->billing_postcode;
			$order_temp['billing_state'] = str_replace($bad_char,"",$order->billing_state); //12
			
			$order_temp['shipping_first_name'] = str_replace($bad_char,"",$order->shipping_first_name);
			$order_temp['shipping_last_name'] = str_replace($bad_char,"",$order->shipping_last_name);
			$order_temp['shipping_address_1'] = str_replace($bad_char,"",$order->shipping_address_1);
			$order_temp['shipping_address_2'] = str_replace($bad_char,"",$order->shipping_address_2);
			$order_temp['shipping_company'] = str_replace($bad_char,"",$order->shipping_company);
			$order_temp['shipping_city'] = str_replace($bad_char,"",$order->shipping_city);
			$order_temp['shipping_postcode'] = $order->shipping_postcode;
			$order_temp['shipping_country'] = str_replace($bad_char,"",$order->shipping_country);	
			$order_temp['shipping_state'] = str_replace($bad_char,"",$order->shipping_state);		
			$order_temp['shipping_method_title'] = $order->shipping_method_title;//22
			
			$order_temp['cart_discount'] = $order->cart_discount;
			$order_temp['cart_discount_tax'] = $order->cart_discount_tax;
			
			
			$order_temp['order_currency'] = $order->order_currency;
			$order_temp['order_discount'] = $order->order_discount;
			$order_temp['order_key'] = $order->order_key;
			$order_temp['order_shipping'] = str_replace($bad_char,"",$order->order_shipping);
			$order_temp['order_shipping_tax'] = $order->order_shipping_tax;
			$order_temp['order_tax'] = $order->order_tax;
			$order_temp['order_total'] = $order->order_total; //31
			
			$order_temp['payment_method'] = str_replace($bad_char,"",$order->payment_method);
			$order_temp['payment_method_title'] = str_replace($bad_char, "",$order->payment_method_title); 
			
			$items = $order->get_items();
			$items_ids = array();
			foreach($items as $key => $item)
			{
				  // Check if product has variation.
				 if ($item['variation_id']) { 
					//$product = new WC_Product($item['variation_id']);
					 $items_ids[] = $item['variation_id'];
					 
					 $variation = new WC_Product_Variation($item['variation_id']);
					 $attributes = $variation->get_variation_attributes();
					 $extra_data = ' - ' . implode( ', ', $attributes ); //&ndash;
						
					 $items[$key]['name'] = $variation->get_title().$extra_data;// $variation->get_formatted_name()
				  } else {
					//$product = new WC_Product($item['product_id']);
					$items_ids[] = $item['product_id'];
				  } 
				  // Get SKU
				  //$items[$key]['sku'] = $product->get_sku();
			}
			 $results = $this->get_sku_by_product_id($items_ids);
			//$this->var_debug($results);
			foreach($items as $key => $item)
			{
				if ($item['variation_id']) 
					$items[$key]['sku'] = isset($results[$item['variation_id']]) ? $results[$item['variation_id']]->sku:"";
				 else 
					$items[$key]['sku'] = isset($results[$item['product_id']]) ? $results[$item['product_id']]->sku:"";
				  
			} 
			
			$order_temp['items'] = $items; //34 - 42
			*/
			array_push($orders_array, $order_temp);
		} 
		echo json_encode($orders_array, JSON_UNESCAPED_UNICODE);
		wp_die(); 
	}
	public function ajax_get_tot_orders_num()
	{
		$this->get_request_parameters();
		$result =  $this->get_order_ids(true);
		echo isset($result) ? $result:0;
		wp_die();
	}
	public function get_order_ids($select_count = false)
	{
		global $wpdb, $wcps_wpml_helper;
		$result = array();
		$total_sale_range = "";
		$date_range = "";
		$status = "";
		$status_joins = "";
		$offset_limit = "";
		$customers_ids_joins = "";
		$customers = "";
		$products_ids_joins = "";
		$products = "";
		$total_sale_user_range = "";
		$customer_post_condition = "";
		$product_pre_condtions = "";
		$lang_array = null;
		 $prepend_before_customers = "";
		/* if(isset($this->min_amount))
			$total_sale_range .= " AND ordermeta.meta_value >= ".$this->min_amount;
		if(isset($this->max_amount))
			$total_sale_range .= " AND ordermeta.meta_value <= ".$this->max_amount;
		if(isset($this->min_amount_total) && isset($this->max_amount_total) && $this->total_amount_spent_filter)
			$total_sale_user_range .= " HAVING (SUM(ordermeta.meta_value) >= ".$this->min_amount_total." AND SUM(ordermeta.meta_value) <= ".$this->max_amount_total.") "; */
		if($this->start_date)
			$date_range .= " AND orders.post_date >= '".$this->start_date."'";
		if($this->end_date)
			$date_range .= " AND orders.post_date <= '".$this->end_date."'";
		if($this->statuses)
		{
			if(function_exists( 'wc_get_order_statuses' )) //2.2 and above
				$status = " AND  orders.post_status IN ('".implode( "','",$this->statuses)."') ";
			else //2.1
			{
				$status_joins = " INNER JOIN {$wpdb->term_relationships} AS rel ON orders.ID=rel.object_ID
								  INNER JOIN {$wpdb->term_taxonomy} AS tax ON tax.term_taxonomy_id = rel.term_taxonomy_id
								  INNER JOIN {$wpdb->terms} AS term ON term.term_id = tax.term_id  ";
				$status = " AND     orders.post_status   = 'publish'
						 AND     tax.taxonomy        = 'shop_order_status'
						 AND     term.term_id           IN ( '" .implode( "','",$this->statuses). "' ) "; 
			}
		}
		if(isset($this->page_num) && isset($this->per_page))
		{
			
			$offset = ($this->page_num-1)*$this->per_page;
			$offset_limit .=  " LIMIT {$offset},{$this->per_page} ";
		}
		/*if($this->customer_ids  || $this->total_amount_spent_filter )*/
		{
			 $customers_ids_joins = " INNER JOIN {$wpdb->postmeta} AS ordermeta_customer ON ordermeta_customer.post_id = orders.ID  ";
			 $customer_post_condition = " AND  ordermeta_customer.meta_key = '_customer_user' "; //AND ordermeta_customer.meta_value > 1 ";
			
			 if($this->customer_ids)
			 {
			   if($this->product_ids || $this->category_ids)
				  $prepend_before_customers = " ( ";
			   $customers= "  AND {$prepend_before_customers} ordermeta_customer.meta_value IN ('" . implode( "','", $this->customer_ids). "' ) ";
			 }
		}
		
		//PRODUCT AND PRODUCT CATEGORIES 	
		$all_product_ids_from_categories = array();
		if($this->category_ids)
		{
			$all_category_ids = array();
			foreach($this->category_ids as $category_id)
				$all_category_ids[$category_id] = array($category_id);
			
			//WPML
			if (class_exists('SitePress')) 
			{
				$languages = icl_get_languages('skip_missing=0&orderby=code');
				$lang_array = array(); 
				if(!empty($languages))
					foreach($languages as $l)
						if(!$l['active']) 
						{
							$all_category_ids[$l['language_code']] = array();
							array_push($lang_array, $l['language_code']);
						}
				foreach($this->category_ids as $category_id)
					foreach($lang_array as $lang)
					{
						if(function_exists('icl_object_id'))
							$translation = icl_object_id($category_id, 'product_cat', false, $lang);
						else
							$translation = apply_filters( 'wpml_object_id', $category_id, 'product_cat', false, $lang );
						
						if($translation)
							array_push($all_category_ids[$category_id], $translation ); 	
					}
			} 
			//End WPML
			
			foreach($all_category_ids as $category_ids_per_language)
			{
				$get_prdocuts_from_categories = " SELECT DISTINCT GROUP_CONCAT(products.ID) as product_ids
										 FROM {$wpdb->posts} AS products 
										 INNER JOIN {$wpdb->term_relationships} AS term_rel ON term_rel.object_id = products.ID
										 INNER JOIN {$wpdb->term_taxonomy} AS term_tax ON term_tax.term_taxonomy_id = term_rel.term_taxonomy_id 
										 INNER JOIN {$wpdb->terms} AS terms ON terms.term_id = term_tax.term_id
										 WHERE  terms.term_id IN ('" . implode( "','", $category_ids_per_language). "')  
										 AND term_tax.taxonomy = 'product_cat' GROUP BY terms.term_id ";
			
				$additional_products = $wpdb->get_results($get_prdocuts_from_categories);
				$additional_products = isset($additional_products) ? $additional_products:array("-1");
				array_push($all_product_ids_from_categories, $additional_products);
			}
			//$this->var_debug($all_product_ids_from_categories);
		}
		if($this->product_ids)
		{
			foreach($this->product_ids as $product_id)
				$all_product_ids[$product_id] = array($product_id);
			//WPML
			if (class_exists('SitePress')) 
			{
				$lang_array = array(); 
				if(!$lang_array)
				{
					$languages = icl_get_languages('skip_missing=0&orderby=code');
					$lang_array = array();
					if(!empty($languages))
						foreach($languages as $l)
							if(!$l['active']) 
							{
							  //$all_product_ids[$l['language_code']] = array();
							  array_push($lang_array, $l['language_code']);
							}
				}
				foreach($this->product_ids as $product_id)
					foreach($lang_array as $lang)
					{
						if(function_exists('icl_object_id'))
							$translation  = icl_object_id($product_id, 'product', false, $lang);
						else
							$translation = apply_filters( 'wpml_object_id', $product_id, 'product', false, $lang );
						
						if($translation)
							array_push($all_product_ids[$product_id], $translation); //array with current id and its translation ids
					}							
			} 
			//End WPML
		}
		if($this->product_ids || $this->category_ids)
		{
			$products_ids_joins = " INNER JOIN {$wpdb->prefix}woocommerce_order_items AS ordermeta_products ON ordermeta_products.order_id = orders.ID  
								INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS ordermeta_product_meta0 ON ordermeta_product_meta0.order_item_id = ordermeta_products.order_item_id ";
			 
			 if(!isset($this->customer_ids))
			 {
				 $products = " AND ( ";
			 }
			 else
				 $products .= " {$this->customer_product_category_filters_relationship} (";
			 
			$product_pre_condtions = " AND ordermeta_product_meta0.meta_key = '_product_id' ";	
		}	
		//products
		$counter = $index = 0;
		if($this->product_ids)	
		{
			$products .= " (";
			foreach($all_product_ids as $products_ids_and_translated_ids)
			{
				if($counter != 0)
				{
					if($this->product_relationship == 'and')
					{
					    $products_ids_joins .= " INNER JOIN {$wpdb->prefix}woocommerce_order_items AS ordermeta_products{$counter} ON ordermeta_products{$counter}.order_id = orders.ID  
											     INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS ordermeta_product_meta{$counter} ON ordermeta_product_meta{$counter}.order_item_id = ordermeta_products{$counter}.order_item_id ";
						$product_pre_condtions .= " AND  ordermeta_product_meta{$counter}.meta_key = '_product_id' ";
						$index = $counter;
					}
					$products .= " {$this->product_relationship} " ;
				}
				$products .= "  ordermeta_product_meta{$index}.meta_value IN ('" .implode( "','", $products_ids_and_translated_ids). "' ) ";
				$counter++;
			}
			$products .= " ) ";
		}
		//categories
		$counter2 = 0;
		if(isset($this->category_ids))
		{
			if(isset($this->product_ids))
				$products .= " {$this->product_category_filters_relationship} (";
			
			foreach($all_product_ids_from_categories as $products_per_category_per_lanuage)
			{
				if(!empty($products_per_category_per_lanuage))
				{
					if($counter != 0)
					{
						if($this->product_category_relationship == 'and')
						{
							$products_ids_joins .= " INNER JOIN {$wpdb->prefix}woocommerce_order_items AS ordermeta_products{$counter} ON ordermeta_products{$counter}.order_id = orders.ID  
													 INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS ordermeta_product_meta{$counter} ON ordermeta_product_meta{$counter}.order_item_id = ordermeta_products{$counter}.order_item_id ";
							$product_pre_condtions .= " AND  ordermeta_product_meta{$counter}.meta_key = '_product_id' ";
							$index = $counter;
						}
						
					}
					if($counter2 != 0)
						$products .= " {$this->product_category_relationship} ";
					
					$ids_temp = array();
					foreach($products_per_category_per_lanuage as $products_per_category)
					{
						$ids_temp = array_merge($ids_temp, explode(",", $products_per_category->product_ids));
						$counter2++;
					}
					$products .= "  ordermeta_product_meta{$index}.meta_value IN ('" . implode( "','", $ids_temp). "' ) ";
					
					$counter++;
				}
			}
			if(isset($this->product_ids))
				$products .= " ) ";
		}
		if($this->product_ids || $this->category_ids)
		{
			if( $prepend_before_customers != "")
				$products .= " ) ";
			$products .= " ) ";
		}
		
		//$wpdb->query('SET OPTION SQL_BIG_SELECTS = 1');
		$wpdb->query('SET SQL_BIG_SELECTS = 1');
		$select_type = "SELECT DISTINCT orders.ID as order_id ";
		if($this->customer_ids || $this->total_amount_spent_filter)
			$select_type = "SELECT ordermeta_customer.meta_value AS user_id, GROUP_CONCAT(DISTINCT orders.ID) AS order_ids, SUM(ordermeta.meta_value) as total_spent ";
		if($select_count)
			$select_type = "SELECT COUNT(DISTINCT orders.ID)  ";
		$query = $select_type.
				 "FROM {$wpdb->posts} as orders
				  INNER JOIN {$wpdb->postmeta} AS presale ON orders.ID = presale.post_id 
				  INNER JOIN {$wpdb->postmeta} AS ordermeta ON orders.ID = ordermeta.post_id ".$status_joins.$customers_ids_joins.$products_ids_joins."
				  WHERE orders.post_type = 'shop_order' ".
				  //AND presale.meta_key LIKE '%wcps_item-%' 
				  "AND presale.meta_key = 'wcps_items' 
				  AND ordermeta.meta_key = '_order_total'
				  AND ordermeta.post_id  = orders.ID ".$total_sale_range.$date_range.$status.$product_pre_condtions.$customers.$products.$customer_post_condition;
		if(!$select_count)
		{
			if($this->customer_ids || $this->total_amount_spent_filter)
				$query .=" GROUP BY ordermeta_customer.meta_value ".$offset_limit ;
			else
				 $query .=" GROUP BY orders.ID ".$offset_limit ;
		}
		else
		{
			$query .= " GROUP BY orders.ID ".$total_sale_user_range;
		}
		$order_ids = $wpdb->get_results($query);
			 
		if($select_count)
			return count($order_ids);
		
		if($this->customer_ids || $this->total_amount_spent_filter)
		{
			//$this->var_debug($order_ids);
			foreach($order_ids as $customer)
			{
				//$this->var_debug("Ok: ".$total_spent.", min: ".$this->min_amount_total.", max: ".$this->max_amount_total) ;
				$orders_ids = explode(",",$customer->order_ids);
				foreach($orders_ids as $order_id)
				{
					 $order = new WC_Order($order_id);
					 array_push($result, $order);
				}
			}
			//$this->var_debug($result);	
		}
		else
			foreach($order_ids as $order_id)
			{ 
				$order = new WC_Order($order_id->order_id);
			   array_push($result, $order);
				
			}
		return $result; 
		
	}	
}
?>