<?php 
class WCPS_Presale
{
	public function __construct()
	{
		//$this->register_cpt();
		//add_action( 'save_post', array(&$this, 'check_if_products_have_already_a_presale' ));
		add_action( 'admin_enqueue_scripts', array(&$this, 'on_presale_edit' ), 10 ,1);
	}
	function register_cpt() 
	{
		$labels = array(
			'name'                => _x( 'Pre Sales', 'Pre Sales', 'woocommerce-pre-sale' ),
			'singular_name'       => _x( 'Pre Sale', 'Pre Sale', 'woocommerce-pre-sale' ),
			'menu_name'           => __( 'Pre Sales', 'woocommerce-pre-sale' ),
			'name_admin_bar'      => __( 'Pre Sale', 'woocommerce-pre-sale' ),
			'parent_item_colon'   => __( 'Parent Item:', 'woocommerce-pre-sale' ),
			'all_items'           => __( 'All Pre Sales', 'woocommerce-pre-sale' ),
			'add_new_item'        => __( 'Add Pre Sale', 'woocommerce-pre-sale' ),
			'add_new'             => __( 'Add Pre Sale', 'woocommerce-pre-sale' ),
			'new_item'            => __( 'New Pre Sale', 'woocommerce-pre-sale' ),
			'edit_item'           => __( 'Edit Pre Sale', 'woocommerce-pre-sale' ),
			'update_item'         => __( 'Update Pre Sale', 'woocommerce-pre-sale' ),
			'view_item'           => __( 'View Pre Sale', 'woocommerce-pre-sale' ),
			'search_items'        => __( 'Search Pre Sale', 'woocommerce-pre-sale' ),
			'not_found'           => __( 'Not found', 'woocommerce-pre-sale' ),
			'not_found_in_trash'  => __( 'Not found in Trash', 'woocommerce-pre-sale' ),
		);
		$args = array(
			'label'               => __( 'Pre Sale', 'woocommerce-pre-sale' ),
			'description'         => __( 'Create pre sales', 'woocommerce-pre-sale' ),
			'labels'              => $labels,
			'menu_icon'           => 'dashicons-tag',//WCPS_PLUGIN_PATH.'/images/WHC-WPPAS-icon2.png', //'dashicons-media-document',
			'supports'            => array('title'),
			//'taxonomies'          => array( 'category', 'post_tag' ),
			'hierarchical'        => false,
			'public'              => true,
			'show_ui'             => true,
			'show_in_menu'        => true,
			//'menu_position'       => $this->get_free_menu_position(50, 0.1),
			'show_in_admin_bar'   => true,
			'show_in_nav_menus'   => true,
			'can_export'          => true,
			'has_archive'         => false,		
			'exclude_from_search' => true,
			'publicly_queryable'  => true,
			'capability_type'     => 'post'
			/* 'rewrite'             => array( 'slug' => 'wppas_photo' ) */
		);
		register_post_type( 'wcps_presale', $args );
		flush_rewrite_rules();
	}
	public function get_free_menu_position($start, $increment = 0.3)
	{
		foreach ($GLOBALS['menu'] as $key => $menu) {
			$menus_positions[] = $key;
		}

		if (!in_array($start, $menus_positions)) return $start;

		/* the position is already reserved find the closet one */
		while (in_array($start, $menus_positions)) {
			$start += $increment;
		}
		return $start;
	}
	public function check_if_products_have_already_a_presale($post_id)
	{
		//drop products that already have a presale active
	}
	public function on_presale_edit($hook)
	{
		global $post, $typenow;
		
		if ( ($hook == 'post.php' || $hook == 'post-new.php') && $typenow == 'wcps_presale') 
		{
			wp_enqueue_style('datepicker-classic', WCPS_PLUGIN_PATH.'/css/datepicker/classic.css');   
			wp_enqueue_style('datepicker-date-classic', WCPS_PLUGIN_PATH.'/css/datepicker/classic.date.css');   
			wp_enqueue_style('datepicker-time-classic', WCPS_PLUGIN_PATH.'/css/datepicker/classic.time.css');  
		
			wp_enqueue_script('ui-picker', WCPS_PLUGIN_PATH.'/js/picker.js', array( 'jquery' ));
			wp_enqueue_script('ui-datepicker', WCPS_PLUGIN_PATH.'/js/picker.date.js', array( 'jquery' ));
			wp_enqueue_script('ui-timepicker', WCPS_PLUGIN_PATH.'/js/picker.time.js', array( 'jquery' )); 
			wp_enqueue_script(  'wcps-date', WCPS_PLUGIN_PATH.'/js/wpcs-admin-presale-post.js' );
		}
	}
}
?>