<?php 
class WCPS_FiltersManager
{
	var $coupon_check_already_performed = array();
	var $product_to_activate_or_to_remove_check_already_preformed = false;
	var $product_filtering_already_preformed = false;
	var $already_add_to_cart_buttons_modified = array();
	var $get_item_price_already_computed = array();
	var $get_item_html_price_already_computed = array();
	var $filter_woocommerce_shortcode_products_query_cache = null;
	public function __construct()
	{
		global  $wcps_option_model;
		//add_action('woocommerce_before_shop_loop_item', array(&$this, 'modify_product_price'));
		
		//COMMON
			//used to display HTML price on single product page before add to cart button. DEPENDS on woocommerce_get_price, and previows filters
		add_filter('woocommerce_get_price_html', array(&$this, 'modify_html_price'), 10, 2 ); 
		add_filter('woocommerce_cart_item_price', array(&$this, 'modify_cart_html_row_price'), 10, 3 ); 
		
		//WC_Variable
			//theorically used in single product page ti display min - max html price
		//add_filter('woocommerce_get_variation_price', array(&$this, 'modify_variable_min_max_product_price'), 10, 4 ); 
		//add_filter('woocommerce_get_variation_regular_price', array(&$this, 'modify_variable_min_max_product_price'), 10, 4 );
		
		///WC_Variation 
			//used to display price on single product page before add to cart button. USELESS, woocommerce_get_price is used
		//add_filter('woocommerce_get_variation_price_html', array(&$this, 'modify_html_price'), 10, 2 ); 
		
		//WC_Product: used everywhere
		add_action( 'wp_loaded', array(&$this, 'init') );	
		
		//add_filter('woocommerce_get_price_including_tax', array(&$this, 'modify_price_witho_or_without_taxes'), 10, 3 );
		//add_filter('woocommerce_get_price_excluding_tax', array(&$this, 'modify_price_witho_or_without_taxes'), 10, 3 );
		
		//Labels
		add_filter( 'add_to_cart_text', array(&$this, 'change_cart_button_text') );
		add_filter( 'woocommerce_product_single_add_to_cart_text', array(&$this, 'change_cart_button_text') );  
		add_filter( 'woocommerce_product_add_to_cart_text', array(&$this, 'change_cart_button_text') );  
		
		//Messagese and countdowns
		add_filter( 'woocommerce_after_shop_loop_item', array(&$this, 'shop_page_single_item_infos_display'),1 );
		//add_filter( 'woocommerce_before_shop_loop_item', array(&$this, 'shop_page_single_item_infos_display') );
		//add_filter( 'woocommerce_shop_loop_item_title', array(&$this, 'shop_page_single_item_infos_display'), 99 ); //Woo Product Multi Layout for WooCommerce
		if(isset($wcps_option_model) && method_exists($wcps_option_model, 'get_option'))
			add_filter( $wcps_option_model->get_option('product_page_infos_display_position'), array(&$this, 'product_single_page_infos_display') );
		else 
			add_filter( 'woocommerce_single_product_summary' , array(&$this, 'product_single_page_infos_display') );
		
		//Shipping check
		add_filter( 'woocommerce_shipping_free_shipping_is_available', array( $this, 'set_free_shipping_for_sales_items' ), 20 );
		
		//Remove expired pre-sales
		add_action('posts_request', array( &$this,'check_product_to_activate_or_remove'));
		
		//Add to cart buttons remover for expired product (IF option has been enabled)
		//if(isset($wcps_option_model) && method_exists($wcps_option_model, 'get_option') && $wcps_option_model->get_option('expired_product_still_visible'))
		{
			add_filter('woocommerce_loop_add_to_cart_link',array( &$this,'remove_shop_page_add_to_cart' ), 10, 2);
			//add_action('init', array( &$this, 'remove_single_product_page_add_to_cart_links'));
			add_action('woocommerce_after_single_product', array( &$this,'force_remove_single_product_page_add_to_cart_button'), 30);
		}
		
		//Add to cart
		add_action('woocommerce_add_to_cart_validation', array(&$this, 'cart_add_to_validation'), 10, 5);
		add_action('woocommerce_update_cart_validation', array(&$this, 'cart_update_validation'), 10, 4);
			//display error message after add to cart check
		//add_action('woocommerce_cart_redirect_after_error', array(&$this, 'add_to_cart_message_on_error'), 10, 2);
		//add_filter( 'woocommerce_add_to_cart_message', array(&$this, 'add_to_cart_message_on_error'), 99);
		
		//Checkout
		add_action('woocommerce_checkout_process', array( &$this, 'checkout_validation' ));
		add_action('woocommerce_checkout_update_order_meta', array( &$this, 'save_data_after_checkout' ));
		add_action('woocommerce_thankyou', array( &$this, 'set_custom_order_status' ), 99);
		
		//Order delete
		add_action('before_delete_post', array( &$this,'update_customer_and_products_total_presasales_info'));
		
		//Coupon
		add_action('woocommerce_coupon_is_valid_for_product', array( &$this,'check_if_coupon_can_be_used'), 10,4);
		
		//Product display filtering
		add_action('pre_get_posts', array( &$this,'filter_products_unavaiable_to_purchase'));
		
		//Sale 
		//badge
		add_filter( 'woocommerce_product_is_on_sale', array(&$this,'show_sale_badge'), 10, 2 );
		add_filter( 'woocommerce_order_item_name', array(&$this,'add_additional_badge_text_to_item_on_product_table'), 99, 3 ); //order-datains-item.php, form-pay.php
		add_filter( 'woocommerce_cart_item_name', array(&$this,'add_additional_badge_text_to_item_on_product_table'), 99, 3 ); //review-order.php, cart.php
		add_filter( 'woocommerce_sale_flash', array(&$this,'override_woocommerce_sale_flash'), 10, 3 ); //Default WooCommerce sale text override
		
		//seach query
		add_filter( 'woocommerce_shortcode_products_query', array(&$this,'filter_woocommerce_shortcode_products_query'), 99, 3 );
		
		//Order details e Email
		//add_filter( 'woocommerce_order_items_meta_display', array( &$this, 'process_order_item_meta_display' ), 99, 2 ); // < 2.7	
		//add_action( 'woocommerce_order_item_meta_end', array( &$this, 'process_order_table_item_name' ),10, 3 ); // > 2.7
		
		//common javascript variables
		add_action('wp_head', array( &$this, 'add_common_js_code'));
	}
	public function init()
	{
		if(version_compare( WC_VERSION, '2.7', '<' ))
		{
			add_filter('woocommerce_get_price', array(&$this, 'modify_product_price'), 10, 2 ); 
		}
		else
		{
			add_filter('woocommerce_product_get_price', array(&$this, 'modify_product_price'), 10, 2 ); 
			add_filter('woocommerce_product_variation_get_price', array(&$this, 'modify_product_price'), 10, 2 ); 
			//add_filter('woocommerce_get_regular_price', array(&$this, 'modify_product_price'), 10, 2 ); //No need
		}
	}
	public function add_common_js_code()
	{
		if(true /* @is_single() || @is_shop() || @is_archive() */ ):
		?>
			<script>
			var wcps_sec_string = "<?php _e('sec', 'woocommerce-pre-sale'); ?>";
			var wcps_min_string = "<?php _e('min', 'woocommerce-pre-sale'); ?>";
			var wcps_hour_string = "<?php _e('hr', 'woocommerce-pre-sale'); ?>";
			var wcps_days_string = "<?php _e('days', 'woocommerce-pre-sale'); ?>";
			var wcps_weeks_string = "<?php _e('weeks', 'woocommerce-pre-sale'); ?>";
			</script>
		<?php endif;
	}
	private function getTextBetweenTags($string, $tagname) {
		$pattern = "/<$tagname ?.*>(.*)<\/$tagname>/";
		preg_match($pattern, $string, $matches);
		return isset($matches[1]) ? $matches[1] : $string;
	}
	
	
	
	//Remove "Add to cart" buttons for Expired products (if option has been enabled)
	public function remove_shop_page_add_to_cart( $add_to_cart_text, $product ) 
	{
		global $wcps_product_model, $wcps_option_model;
		$can_render = true;
		if(!$wcps_product_model->if_before_start_date_can_be_purchased($product->get_id()))
		{
			$can_render = false;
		}
		
		if(isset($wcps_option_model) && method_exists($wcps_option_model, 'get_option') && $wcps_option_model->get_option('expired_product_still_visible'))
		{
			/* if(isset($this->already_add_to_cart_buttons_modified[$product->get_id()]))
				return;
					$this->already_add_to_cart_buttons_modified[$product->get_id()] = true;  */
			
			if($wcps_product_model->is_expired($product->get_id()))
			{
				$can_render = false;
				
			}
		}
		
		if($can_render)
			echo $add_to_cart_text; 
	}
	public function remove_single_product_page_add_to_cart_links()
	{
		
		remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30 ); 
		add_action( 'woocommerce_single_product_summary', array( &$this,'remove_single_product_page_add_to_cart_link' ), 30);
	}
	public function remove_single_product_page_add_to_cart_link() 
	{
		global $product, $wcps_product_model;
		/* if(isset($this->already_add_to_cart_buttons_modified[$product->get_id()]))
			return;
		$this->already_add_to_cart_buttons_modified[$product->get_id()] = true;  */
		
		
		if(!$wcps_product_model->is_expired($product->get_id()))
		{
			woocommerce_template_single_add_to_cart();
		}
		
	}
	//forced
	public function force_remove_single_product_page_add_to_cart_button()
	{
		//FORCING ADD TO CART HIDING
		//note: some themes doens't lauch the correct event
		global $product, $wcps_product_model, $wcps_option_model;
		$if_before_start_date_can_be_purchased = $wcps_product_model->if_before_start_date_can_be_purchased($product->get_id());
	
		if( (isset($wcps_option_model) && method_exists($wcps_option_model, 'get_option') && $wcps_option_model->get_option('expired_product_still_visible')) ||
		     !$if_before_start_date_can_be_purchased)
		{
			if($wcps_product_model->is_expired($product->get_id()) || !$if_before_start_date_can_be_purchased):
			
			?>
			<script>
			function wcps_remove_add_to_cart(event)
				{
					event.stopImmediatePropagation();
					event.preventDefault();
					return false;
				}
				
			
				jQuery('.single_add_to_cart_button').css('display', 'none');
				jQuery('.cart').css('display', 'none');
				jQuery('.cart').css('opacity', 0);
				jQuery('.qty-cart').css('display', 'none');
				jQuery('.qty-cart').css('opacity', 0);
				jQuery('.single_add_to_cart_button').click(wcps_remove_add_to_cart);
			jQuery(document).ready(function()
			{	
				jQuery('.qty-cart').remove();
				jQuery('.single_add_to_cart_button').remove();
			});
			</script>
			<?php
			endif;
		}
	}
	//end Remove
	
	//NOT USED /////////////////////////////////////////////////
	function modify_variable_min_max_product_price( $price, $instance, $min_or_max, $display ) 
	{
		//wcps_var_dump($price);	
		$price = rand();
		return $price;
	}
	function modify_price_witho_or_without_taxes($price, $qty, $instance)
	{
		
		return $price;
	}
	//////////////////////////////////////////////////////////
	
	function filter_products_unavaiable_to_purchase( $main_query ) 
	{
		/* if($this->product_filtering_already_preformed) 
			return $main_query;
		$this->product_filtering_already_preformed = true; */
		global $wcps_product_model;
		
		if ( !is_admin() ) 
		{
			// wcps_var_dump($wcps_product_model->get_product_ids_with_presale_active());
			$products_ids = $wcps_product_model->hide_product_for_non_allowed_users();
			if(!empty($products_ids))
				$main_query->set('post__not_in', $products_ids); 
		}
	}
	
	function filter_woocommerce_shortcode_products_query( $query_args, $atts, $loop_name = '' ) 
	{ 
		global $wcps_product_model, $wcps_option_model;
		
		if($loop_name != 'sale_products' || !$wcps_option_model->get_option('enable_sale_products'))
			return $query_args;
		
		
		$all_products = $wcps_product_model->get_product_list(null, true);
		//wcps_var_dump($query_args);
		$var_counter = 0;
		if(!isset($query_args["posts_per_page"]))
			$query_args["posts_per_page"] = 12;
		if(!isset($this->filter_woocommerce_shortcode_products_query_cache))
		{
			$this->filter_woocommerce_shortcode_products_query_cache = array();
			if(isset($all_products) && is_array($all_products) && !empty($all_products))
			{
				foreach($all_products as $product)
				{
					$tmp_product = wc_get_product($product->id);
					$is_on_sale = false;
					if($wcps_product_model->is_presale_active($product->id) && $this->show_sale_badge(false, $tmp_product, true))
					{
						$query_args["post__in"][] = $product->id;
						$this->filter_woocommerce_shortcode_products_query_cache[] = $product->id;
						$is_on_sale = true;
						
					}
					/* else if( $tmp_product->is_on_sale( )) //No need, in the  $query_args there are already sale products
						$is_on_sale = true; */
					
					if($is_on_sale)
						if($var_counter++ == $query_args["posts_per_page"])
								break;
				}
			}
		}
		else 
			foreach((array)$this->filter_woocommerce_shortcode_products_query_cache as $cached_id)
				$query_args["post__in"][] = $cached_id;
				
		return $query_args; 
	}
	function add_additional_badge_text_to_item_on_product_table($product_title, $item, $cart_item_key_or_is_visible)
	{
		global $wcps_product_model, $wcps_option_model;
		//$product_title: for  'woocommerce_order_item_name' is text, for 'woocommerce_cart_item_name' is an hyperlink <a>
	
		//$cart_item_key: for  woocommerce_cart_item_name
		//$is_visible: for  woocommerce_order_item_name
		
		if($wcps_product_model->is_presale_active($item['product_id']))
		{
			$sale_text = $wcps_product_model->get_option($item['product_id'], 'wcps_badge_text_next_to_product');
			$sale_text = !isset($sale_text) || $sale_text == "" ? $wcps_option_model->get_option('badge_text_next_to_product') : $sale_text;
			if(isset($sale_text) && $sale_text != "")
				$product_title .= " ".$sale_text;
		}
		
		return $product_title;
	}
	function override_woocommerce_sale_flash($html_text, $post, $product)
	{
		global $wcps_product_model, $wcps_option_model;
		$display_badge = $wcps_option_model->get_option('show_sale_badge');
		
		if($wcps_product_model->is_presale_active($post->ID) && isset($display_badge))
		{
			$sale_badge_text = $wcps_product_model->get_option($post->ID, 'wcps_sale_badge_text');
			$sale_badge_text = !isset($sale_badge_text) || $sale_badge_text == "" ? $wcps_option_model->get_option('default_sale_badge_text') : $sale_badge_text;
			if(isset($sale_badge_text) && $sale_badge_text != "")
				$html_text = '<span class="onsale">' . $sale_badge_text . '</span>';
		}
		return $html_text; 
	}
	function show_sale_badge( $is_on_sale, $product, $force_is_on_sale_check = false ) 
	{ 
		if(is_admin())
			return $is_on_sale;
		
		global  $wcps_product_model, $wcps_option_model;	
		$display_badge = $wcps_option_model->get_option('show_sale_badge');
		
		if(!isset($display_badge) && !$force_is_on_sale_check)
			return $is_on_sale;
		
		if(is_a($product, 'WC_Product_Variable'))
		{
			$min = $wcps_product_model->get_presale_price_if_any($product->get_id(), $product->get_variation_price()); // $temp->get_variation_price();
			$max = $wcps_product_model->get_presale_price_if_any($product->get_id(), $product->get_variation_price('max'));  //$temp->get_variation_price('max');
			$old_numeric_min = $product->get_variation_regular_price();
			$old_numeric_max = $product->get_variation_regular_price('max');
			/* wcps_var_dump($min." ".$old_numeric_min);
			wcps_var_dump($max." ".$old_numeric_max); */
			if( $min < $old_numeric_min  || $max < $old_numeric_max)
			{
				//wcps_var_dump("sale");
				return true;
			}
		}
		else 
		{
			$temp_price =  $wcps_product_model->get_presale_price_if_any($product->get_id(), $product->get_regular_price());
			if($temp_price < $product->get_regular_price()) 
				return true;
		}
		
		return $is_on_sale;
	}
	
	function modify_cart_html_row_price($price, $cart_item, $cart_item_key)
	{
		return $this->modify_html_price($price, $cart_item['data'], true);
	}
	//Used to display variable products Min Max price (HTML)
	function modify_html_price($price, $instance, $is_cart = false) 
	{
		if(is_admin())
			return $price; 
		
		if(isset($this->get_item_html_price_already_computed[$instance->get_id()]) && !is_a($instance, 'WC_Product_Variation'))
			return $this->get_item_html_price_already_computed[$instance->get_id()];
		
		global $wcps_option_model, $wcps_product_model;
		$disable_tax_application = $wcps_option_model->get_option('disable_tax_application');
		$display_tax = !$is_cart ? get_option('woocommerce_tax_display_shop') : get_option('woocommerce_tax_display_cart');
		$display_tax = $disable_tax_application ? 'excl' : $display_tax;
		$prices_entered_include_tax = get_option('woocommerce_prices_include_tax');
		$price_display_suffix = get_option('woocommerce_price_display_suffix');
		$price_display_suffix = $display_tax == 'incl' && !$is_cart ? $price_display_suffix : "";
		
		
		
		/* if(function_exists('get_current_screen'))
		{
			$screen_id = get_current_screen()->id;
			if(is_admin() && $screen_id == "edit-product")
				return $price;
		} */
		
		if(!$wcps_product_model->is_presale_active($instance->get_id()))
			return $price;
		
		//$price = HTML String ---> €1,00–€3,00  get_woocommerce_currency_symbol
		$old_variable_product_show_price_method = $wcps_option_model->get_option('old_variable_product_show_price_method');
		$display_old_price = $wcps_product_model->get_option($instance->get_id(), 'wcps_data','display_old_price');
		$display_badge = $wcps_option_model->get_option('show_sale_badge');
		$old_price = $price;
		$is_variation = false; 
		if(is_a($instance, 'WC_Product_Variable'))
		{
			$my_parent_id = method_exists ( $instance, 'get_parent_id') ?  $instance->get_parent_id() : $instance->get_id(); //pre 3.0 compability
			$is_variation = true;
			$temp = new WC_Product_Variable($instance->get_id());
			$min = $wcps_product_model->get_presale_price_if_any($instance->get_id(), $temp->get_variation_price()); // $temp->get_variation_price();
			$max = $wcps_product_model->get_presale_price_if_any($instance->get_id(), $temp->get_variation_price('max'));  //$temp->get_variation_price('max');
			
			$old_numeric_min = $instance->get_variation_regular_price();
			$old_numeric_max = $instance->get_variation_regular_price('max');
			
			$tax = WCPS_Tax::get_product_price_excluding_tax($instance) != 0 ? WCPS_Tax::get_product_price_including_tax($instance)/WCPS_Tax::get_product_price_excluding_tax($instance) : null;
			/* if($prices_entered_include_tax == 'yes' && isset($tax) && $tax != 0)
			{
				$min = $min / $tax;
				$max = $max / $tax;
				$old_numeric_min = $old_numeric_min / $tax;
				$old_numeric_max = $old_numeric_max / $tax;
			} */
			
			if($old_numeric_min != $old_numeric_max)
				$old_price = $display_tax == 'incl' && isset($tax) && $tax != 0 ?  wc_price($old_numeric_min*$tax). " - ".wc_price($old_numeric_max*$tax) : wc_price($old_numeric_min). " - ".wc_price($old_numeric_max);
			else
				$old_price = $display_tax == 'incl' && isset($tax) && $tax != 0 ?  wc_price($old_numeric_min*$tax): wc_price($old_numeric_min);
			
				
			$min_max_html_text = $display_tax == 'incl' && isset($tax) && $tax != 0 ?  wc_price($min*$tax). " - ".wc_price($max*$tax) : wc_price($min). " - ".wc_price($max);
			$min_html_text = $display_tax == 'incl' && isset($tax) && $tax != 0 ?  wc_price($min*$tax) : wc_price($min);
			
			$price = !isset($old_variable_product_show_price_method) || $old_variable_product_show_price_method != true ? $min_max_html_text : '<span class="from wcps_variable_price_from">'.__("From: ","woocommerce-pre-sale").' </span>'.$min_html_text;
			
			//In case it was free and still is free no html price manipulation
			if( $old_numeric_min == 0 && $old_numeric_max ==  0 && $min ==  0 && $max == 0)
				return $old_price; //Free! text 
			if( wc_price($min) == wc_price($max))
					$price = $display_tax == 'incl' && isset($tax) && $tax != 0 ?  wc_price($min*$tax) : wc_price($min);
				
		}
		else if(isset($display_old_price) /* || isset($display_badge) */) //Simple
		{
			$tax = WCPS_Tax::get_product_price_excluding_tax($instance) != 0 ? WCPS_Tax::get_product_price_including_tax($instance)/WCPS_Tax::get_product_price_excluding_tax($instance) : null;
			$original_price = $instance->get_regular_price();
			if(is_a($instance, 'WC_Product_Booking'))
				$original_price = $instance->get_price('wcps');
			
			if( !$disable_tax_application && $prices_entered_include_tax == 'yes' && isset($tax) && $tax != 0)
				$original_price = $original_price / $tax;
			
			$temp_price =  $wcps_product_model->get_presale_price_if_any($instance->get_id(), $original_price, false);
			
			if( is_numeric($temp_price)) //if is numeric is a new price
			{
				if(!$disable_tax_application && !is_a($instance, 'WC_Product_Variation') && $prices_entered_include_tax == 'yes' && isset($tax) && $tax != 0)
					$temp_price = $temp_price / $tax;
				
				//In case it was free and still is free no html price manipulation
				if( $original_price == 0 && $temp_price == 0)
					return $old_price;
			
				$old_price = $original_price;
				
				
				//if($display_items_price_without_tax == 'no')
				{
					$price = $display_tax == 'incl' && isset($tax) && $tax != 0 ? wc_price($temp_price*$tax): wc_price($temp_price);
					$old_price = $display_tax == 'incl' && isset($tax) && $tax != 0 ? wc_price($old_price*$tax): wc_price($old_price);
				}
				
				/* else
				{
					$price =  wc_price($temp_price);
					$old_price =  wc_price($old_price);
				} */
			}
			/* $old_price = $old_html_price;
			wcps_var_dump($old_price);
			wcps_var_dump($this->getTextBetweenTags($price, 'span'));
			wcps_var_dump($this->getTextBetweenTags($old_price, 'span')); */
		}
		if((isset($display_old_price) /* || isset($display_badge) */) && ((!$old_variable_product_show_price_method  && $price != $old_price) || ($old_variable_product_show_price_method && ($this->getTextBetweenTags($price, 'span') != $old_price/* $this->getTextBetweenTags($old_price, 'span') */))))
		{
			if($old_variable_product_show_price_method)
			{
				$old_price = explode(" - ",$old_price);
				$old_price = __("From: ","woocommerce-pre-sale").$old_price[0];
			}
			$price = '<span style="color:#c3c3c3; text-decoration: line-through;">'.strip_tags($old_price).'</span> '.$price;
		}
		$this->get_item_html_price_already_computed[$instance->get_id()] = $price.$price_display_suffix;
		return $price.$price_display_suffix;
	}
	//Filters
	//applied to all prices
	function modify_product_price($price, $instance) 
	{
		if(is_admin())
			return $price; 
		
		
		if(!is_a($instance, 'WC_Product_Variable') && !is_a($instance, 'WC_Product_Variation') && isset($this->get_item_price_already_computed[$instance->get_id()]))
			return $this->get_item_price_already_computed[$instance->get_id()];
		
		/* if(function_exists('get_current_screen'))
		{
			$screen_id = get_current_screen()->id;
			if(is_admin() && $screen_id == "edit-product")
				return $price;
		} */
		
		//wcps_var_dump($instance);
		/* if(isset($instance->variation_id))
		{
			echo "variation";
			wcps_var_dump($instance->variation_id);
		}
		else
			wcps_var_dump($instance->id);		 */
		//wcps_var_dump($price);	
		global $wcps_product_model;
		$my_parent_id = is_a($instance, 'WC_Product_Variation') && method_exists ( $instance, 'get_parent_id') ?  $instance->get_parent_id() : $instance->get_id(); //pre 3.0 compability
		$this->get_item_price_already_computed[$instance->get_id()] = $wcps_product_model->get_presale_price_if_any($my_parent_id , $price);
		return $this->get_item_price_already_computed[$instance->get_id()];
	}
	function change_cart_button_text($text) 
	{
		global $wcps_product_model, $product;
		//wcps_var_dump($product);
		if(isset($product) && is_object($product) && $wcps_product_model->is_presale_active($product->get_id()))
		{
			$wcps_add_to_cart_text = $wcps_product_model->get_option($product->get_id(), 'wcps_add_to_cart_text');
			if(isset($wcps_add_to_cart_text) && !empty($wcps_add_to_cart_text))
				return $wcps_add_to_cart_text;
			//return __( 'Pre-order', 'woocommerce-pre-sale' );
		}
		
		return $text;
	}
	public function shop_page_single_item_infos_display()
	{
		global $post,$wcps_option_model,$wcps_product_model;
		$product_data = $wcps_product_model->get_presale_periods_info($post->ID);
		/* if($post->ID == 13)
			wcps_var_dump($product_data); */
		if(isset($product_data) && !$product_data['is_expired'] && ($product_data['is_active'] || $product_data['going_to_activate']))
		{
			$wcps_shop_page_message = $wcps_product_model->get_option($post->ID, 'wcps_shop_page_message');
			
			$wcps_data = $wcps_product_model->get_option($post->ID, 'wcps_data');
			$time_offset =  $wcps_option_model->get_option('time_offset');			
			$timer_disable_week_counter =  $wcps_option_model->get_option('timer_disable_week_counter');
			$timer_disable_minute_counter = $wcps_option_model->get_option('timer_disable_minute_counter');
			$timer_disable_second_counter = $wcps_option_model->get_option('timer_disable_second_counter');			
			$show_end_type_only_after_start_date = isset($wcps_data['countdown_timer_only_after_start_date']) ? $wcps_data['countdown_timer_only_after_start_date'] : null;
			$show_end_type_only_after_start_date = !isset($show_end_type_only_after_start_date) ? "no" : $show_end_type_only_after_start_date;
			$difference = $time_to_end = $time_to_start = -1;
			
			$wcps_data["expiring_time"] = $wcps_data["expiring_time"] == "" ? "23:59" : $wcps_data["expiring_date"];
			$wcps_data["start_time"] = $wcps_data["start_time"] == "" ? "00:00" : $wcps_data["start_time"];
			$time_to_end = !empty($wcps_data["expiring_date"]) && $wcps_data["expiring_date"] != "" ? strtotime($wcps_data["expiring_date"]." ".$wcps_data["expiring_time"]) - strtotime(date('Y/m/d H:i:s', strtotime($time_offset.' minutes'))) : 0;
			$time_to_start = !empty($wcps_data["start_date"]) && $wcps_data["start_date"] != "" ? strtotime($wcps_data["start_date"]." ".$wcps_data["start_time"]) - strtotime(date('Y/m/d H:i:s', strtotime($time_offset.' minutes'))) : 0;

			$sales_progress_bar_background_color = isset($wcps_data['sales_progress_bar_background_color']) && $wcps_data['sales_progress_bar_background_color'] != '' ? $wcps_data['sales_progress_bar_background_color']: '#3d3d3d';
			$sales_progress_bar_color = isset($wcps_data['sales_progress_bar_color']) && $wcps_data['sales_progress_bar_color'] != '' ? $wcps_data['sales_progress_bar_color']: '#d3d3d3';
			$where_to_display_progress_bar = isset($wcps_data['sales_progress_bar']) ? $wcps_data['sales_progress_bar'] : "no";
			$goal_threshold = isset($wcps_data['threshold']) ? $wcps_data['threshold']: 0;
			$current_sales = $wcps_product_model->get_total_sales($post->ID);
			$progress_value = $goal_threshold > 0  ? ($current_sales/$goal_threshold)*100 : 0;
			$progress_value = $progress_value > 100 ? 100 : $progress_value;
			$progress_label = isset($wcps_data['sales_progress_bar_label']) ? $wcps_data['sales_progress_bar_label'] : "no";
				
			if($product_data['is_presale_system_active'] && $product_data['going_to_activate'] && $time_to_start > 0 && ($wcps_data['countdown_to_start_timer_display'] == 'shop_page' || $wcps_data['countdown_to_start_timer_display'] == 'both_pages'))
			{	
				$difference = $time_to_start;
			}
			elseif($product_data['is_presale_system_active'] && $time_to_end > 0 && ($show_end_type_only_after_start_date == 'no' || ($show_end_type_only_after_start_date == 'yes' && ($time_to_start <= 0 || !isset($time_to_start))) )
									&& ($wcps_data['countdown_timer_display'] == 'shop_page' || $wcps_data['countdown_timer_display'] == 'both_pages'))
									{
										$difference = $time_to_end;
									}
			wp_enqueue_script('wcps-countdown', WCPS_PLUGIN_PATH.'/js/wcps-frontend-countdown.js', array('jquery')); 
			wp_enqueue_script('wcps-jquery-countdown', WCPS_PLUGIN_PATH.'/js/jquery.countdown.js', array('jquery')); 
			wp_enqueue_script('wpcs-data-formatter', WCPS_PLUGIN_PATH.'/js/wpcs-data-formatter.js', array('jquery')); 
			wp_enqueue_style('wcps-msg-countdown', WCPS_PLUGIN_PATH.'/css/wcps-frontend-addon-msg-countdown.css'); 
			
			include WCPS_PLUGIN_ABS_PATH."/templates/shop_loop_item.php";
		}
		elseif($product_data['is_expired'])
		{
			$wcps_expired_shop_page_message = $wcps_product_model->get_option($post->ID, 'wcps_expired_shop_page_message');
			include WCPS_PLUGIN_ABS_PATH."/templates/shop_loop_expired_item.php";
		}
	}
	public function product_single_page_infos_display()
	{
		global $post,$wcps_option_model,$wcps_product_model;
		$product_data = $wcps_product_model->get_presale_periods_info($post->ID);
		if(isset($product_data) && !$product_data['is_expired'] && ($product_data['is_active'] || $product_data['going_to_activate']))
		{
			$wcps_product_page_message = $wcps_product_model->get_option($post->ID, 'wcps_product_page_message');
			
			$wcps_data = $wcps_product_model->get_option($post->ID, 'wcps_data');
			$time_offset =  $wcps_option_model->get_option('time_offset');	
			$timer_disable_week_counter =  $wcps_option_model->get_option('timer_disable_week_counter');
			$timer_disable_minute_counter = $wcps_option_model->get_option('timer_disable_minute_counter');
			$timer_disable_second_counter = $wcps_option_model->get_option('timer_disable_second_counter');			
			$show_end_type_only_after_start_date = $wcps_data['countdown_timer_only_after_start_date'];
			$show_end_type_only_after_start_date = !isset($show_end_type_only_after_start_date) ? "no" : $show_end_type_only_after_start_date;
			$difference = -1;
			
			$wcps_data["expiring_time"] = $wcps_data["expiring_time"] == "" ? "23:59" : $wcps_data["expiring_date"];
			$wcps_data["start_time"] = $wcps_data["start_time"] == "" ? "00:00" : $wcps_data["start_time"];
			$time_to_end = !empty($wcps_data["expiring_date"]) && $wcps_data["expiring_date"] != "" ? strtotime($wcps_data["expiring_date"]." ".$wcps_data["expiring_time"]) - strtotime(date('Y/m/d H:i:s', strtotime($time_offset.' minutes'))): 0;
			$time_to_start = !empty($wcps_data["start_date"]) && $wcps_data["start_date"] != "" ? strtotime($wcps_data["start_date"]." ".$wcps_data["start_time"]) - strtotime(date('Y/m/d H:i:s', strtotime($time_offset.' minutes'))): 0;
			
			$sales_progress_bar_background_color = isset($wcps_data['sales_progress_bar_background_color']) && $wcps_data['sales_progress_bar_background_color'] != '' ? $wcps_data['sales_progress_bar_background_color']: '#3d3d3d';
			$sales_progress_bar_color = isset($wcps_data['sales_progress_bar_color']) && $wcps_data['sales_progress_bar_color'] != '' ? $wcps_data['sales_progress_bar_color']: '#d3d3d3';
			$where_to_display_progress_bar = isset($wcps_data['sales_progress_bar']) ? $wcps_data['sales_progress_bar'] : "no";
			$goal_threshold = isset($wcps_data['threshold']) ? $wcps_data['threshold']: 0;
			$current_sales = $wcps_product_model->get_total_sales($post->ID);
			$progress_value = $goal_threshold > 0  ? ($current_sales/$goal_threshold)*100 : 0;
			$progress_value = $progress_value > 100 ? 100 : $progress_value;
			$progress_label = isset($wcps_data['sales_progress_bar_label']) ? $wcps_data['sales_progress_bar_label'] : "no";
		
			if($product_data['is_presale_system_active'] && $product_data['going_to_activate'] && $time_to_start > 0 && ($wcps_data['countdown_to_start_timer_display'] == 'product_page' || $wcps_data['countdown_to_start_timer_display'] == 'both_pages'))
			{	
				$difference = $time_to_start;
				//wcps_var_dump("before");
			}
			elseif($product_data['is_presale_system_active'] && $time_to_end > 0 && ($show_end_type_only_after_start_date == 'no' || ($show_end_type_only_after_start_date == 'yes' && ($time_to_start <= 0 || !isset($time_to_start))))
									&& ($wcps_data['countdown_timer_display'] == 'product_page' || $wcps_data['countdown_timer_display'] == 'both_pages'))
			{
				$difference = $time_to_end;
				//wcps_var_dump("after");
			}	
			/* wcps_var_dump($show_end_type_only_after_start_date == 'yes' && ($time_to_start < 0 || !isset($time_to_start)));
			wcps_var_dump($show_end_type_only_after_start_date == 'yes');
			wcps_var_dump($time_to_start); */
			
			wp_enqueue_script('wcps-countdown', WCPS_PLUGIN_PATH.'/js/wcps-frontend-countdown.js', array('jquery'));  
			wp_enqueue_script('wcps-jquery-countdown', WCPS_PLUGIN_PATH.'/js/jquery.countdown.js', array('jquery'));
			wp_enqueue_script('wpcs-data-formatter', WCPS_PLUGIN_PATH.'/js/wpcs-data-formatter.js', array('jquery')); 
			wp_enqueue_style('wcps-msg-countdown', WCPS_PLUGIN_PATH.'/css/wcps-frontend-addon-msg-countdown.css'); 
			
			include WCPS_PLUGIN_ABS_PATH."/templates/single_page.php";
		}
		elseif($product_data['is_expired'])
		{
			$wcps_expired_product_page_message = $wcps_product_model->get_option($post->ID, 'wcps_expired_product_page_message');
			include WCPS_PLUGIN_ABS_PATH."/templates/single_page_expired.php";
		}
	}
	public function check_product_to_activate_or_remove($input)
	{
		/* if($this->product_to_activate_or_to_remove_check_already_preformed)
			return $input;
		$this->product_to_activate_or_to_remove_check_already_preformed = true;  */
				
		global $wcps_product_model;
		
		if( !is_admin() && ( @is_single() || @is_shop() || @is_archive() || @is_category() || @is_page() /* ||@is_checkout() || @is_cart() */))
		{
			
			$wcps_product_model->check_products_to_show_or_hide_after_presale();
		} 
		return $input;
	}
	//On Order delete
	public function update_customer_and_products_total_presasales_info($order_id)
	{
		global $post_type, $wcps_product_model, $wcps_customer_model;   
		if($post_type !== 'shop_order') return;
		
		$order = new WC_Order($order_id);
		$user_id = $order->customer_user;
		$products = $order->get_items();
		foreach($products as $order_item_id => $product)
		{
			$is_presale = wc_get_order_item_meta( $order_item_id, '_wcps_presale');
			$is_deposit = wc_get_order_item_meta( $order_item_id, '_wcps_is_deposit');
			$coupon_id = wc_get_order_item_meta( $order_item_id, '_wpcs_coupon_id');
			$is_deposit = isset($is_deposit) && $is_deposit != '' ? $is_deposit:false;
			/* wcps_var_dump($is_presale);
			wcps_var_dump($product);
			wcps_var_dump($order_item_id); */
			if($is_presale)
			{
				$wcps_customer_model->update_presale_meta_info($user_id,  $product['product_id'], $product['qty'],false,true);
				//$wcps_customer_model->update_deposit_meta_info($user_id, $product['product_id'], $product['variation_id'], $product['quantity'],  true);
				$wcps_product_model->update_total_presales($product['product_id'], $product['qty'], false, true);
				if($is_deposit && $coupon_id)
					wp_delete_post($coupon_id,true);
			}
		}
		//wp_die();
	}
	//Add to cart                           //true or false
	public function cart_add_to_validation( $original_result, $product_id, $quantity , $variation_id = 0, $variations = null )
	{
		global $woocommerce,$wcps_product_model;

		//wcps_var_dump($product_id." ".$quantity);
		//wcps_var_dump(WC()->cart);
		//WC()->cart
		//$woocommerce->add_error( sprintf( "You must add a minimum of %s %s's to your cart to proceed." , $minimum, $product_title ) );
		$result = $wcps_product_model->customer_can_purchase_product($product_id,  $variation_id,  $quantity, false);
		if(!$result['result'])
			foreach($result['messages'] as $message)
				wc_add_notice( $message ,'error');
		
		if($result['result'] == true)
			$result['result'] = $original_result;
		
		return $result['result'];
	}
	//Update cart
	public function cart_update_validation($original_result, $cart_item_key, $values, $quantity )
	{
		//wcps_var_dump(WC()->cart->get_cart());
		global $woocommerce,$wcps_product_model;
		$result = array('result' => $original_result);
		$items = WC()->cart->cart_contents;
		if(isset($items[$cart_item_key]))
		{
			$items[$cart_item_key]['data']->virtual = true;
			$result = $wcps_product_model->customer_can_purchase_product($items[$cart_item_key]['product_id'], $items[$cart_item_key]['variation_id'], $quantity);
			if(!$result['result'])
				foreach($result['messages'] as $message)
					wc_add_notice( $message ,'error');
		}
		
		return $result['result'];
	}
	public function set_free_shipping_for_sales_items( $is_available ) {
		global $woocommerce,$wcps_product_model;
		//$eligible = array( 'free-shipping' );
		$cart_items = $woocommerce->cart->get_cart();
		foreach ( $cart_items as $key => $item ) 
		{
			$result = $wcps_product_model->customer_can_purchase_product($item['product_id'], $item['variation_id']);
			if($result['is_virtual'])
				 $item['data']->virtual = true;
			/* if ( ! in_array( $item['data']->get_shipping_class(), $eligible ) ) 
			{
				// this item doesn't have the right class. return false
				return false;
			} */
		}
		// nothing out of the ordinary return the default value
		return $is_available;
	}
	//Coupon apply (cannot be used a wcps discount coupon during presale period
	public function check_if_coupon_can_be_used( $valid, $product, $coupon_obj, $values ) 
	{
		global $wcps_product_model, $wcps_option_model;
		//$product_id = $wcps_product_model->is_a_deposit_deduction_coupon($the_coupon);
		//wcps_var_dump($product->variation_id);
		if(isset($this->coupon_check_already_performed[$product->get_id()]))
			return $this->coupon_check_already_performed[$product->get_id()];
		
		$coupon_code_can_be_used_when_item_is_in_presale = $wcps_option_model->get_option('coupon_code_can_be_used_when_item_is_in_presale');
		
		if($valid && $product->get_id() > 0 && (!$coupon_code_can_be_used_when_item_is_in_presale && $wcps_product_model->is_presale_active($product->get_id())))
		{
			$this->coupon_check_already_performed[$product->get_id()] = true;
			//wcps_var_dump($coupon_obj);
			WC()->cart->remove_coupon($coupon_obj->code);
			wc_add_notice( sprintf(__('This coupon cannot be applied for %s during this period.', 'woocommerce-pre-sale'), $product->post->post_title), 'error' );
			return false;
		} 
		return $valid;
	}
	//Checkout
	public function checkout_validation()
	{
		//setting a wc_add_notice 'error' will stop checkout process
		$error = false;
		global $wcps_product_model , $wcps_cart_model ;
		$results = $wcps_product_model->validate_current_customer_cart();
		foreach($results as $result)
			if(!$result['result'])
			{
				$error = true;
				foreach($result['messages'] as $message)
					wc_add_notice( $message ,'error');
			}
		 if(!$error)
		{
			//wcps_var_dump($results);
			foreach($results as $result)	
				if($result['is_presale'] && isset($result['cart_item_key']) )
				{
					//$quantity = $wcps_cart_model->get_item_data( $result['cart_item_key'], 'quantity', 0 );
					$wcps_cart_model->set_item_data( $result['cart_item_key'], 'quantity', /* $quantity +  */$result['quantity'] );
					
					if($result['is_deposit_active'])
						$wcps_cart_model->set_item_data( $result['cart_item_key'], 'is_deposit', true );
					else
						$wcps_cart_model->set_item_data( $result['cart_item_key'], 'is_deposit', false );
				}
		} 
	}
	public function process_order_item_meta_display($original_text, $item )
	{
		if(version_compare( WC_VERSION, '2.7', '>' ))
			return $original_text;
		
		$coupon = new WCPS_Coupon();
		$coupon_code = $coupon->get_order_item_coupon_code($item);
		
		return $coupon_code != false ? $original_text."<br/>".$coupon_code : $original_text;
	}
	public function process_order_table_item_name( $item_id, $item, $order)
	{
		if(version_compare( WC_VERSION, '2.7', '<' ))
			return ;
		
		$coupon = new WCPS_Coupon();
		$coupon_code = $coupon->get_order_item_coupon_code($item);
		
		
		echo $coupon_code != false ? "<br/>".$coupon_code : "";
	}
	function save_data_after_checkout( $order_id ) 
	{
		global $wcps_order_model, $wcps_customer_model, $wcps_product_model ,$wcps_cart_model,$wcps_option_model;
		$product_ids = array();
		$quantities = array();
		//$product_is_deposit = array();
	    $order = wc_get_order($order_id);
		if(!isset($order) || $order == false)
			return;
		
		$user_id = $order->get_customer_id();
		$products = $order->get_items();
		$order_status_to_assign_after_checkout = $wcps_option_model->get_option('order_status_to_assign_after_checkout');
		/* foreach($products as $product)
		{
			if($wcps_product_model->is_presale_active($product['product_id']))
			{
				if(isset($user_id) && $user_id > 0)
					$wcps_customer_model->update_presale_meta_info($user_id,  $product['product_id'], $product['qty']);
				$temp_id = $product['product_id'];
				if(isset($product['variation_id']) && $product['variation_id'] != '')
					$temp_id .="_".$product['variation_id'];
				
				$product_ids[] = $temp_id;
				$wcps_product_model->update_total_presales($product['product_id'], $product['qty']);
				
			}
		}  */
		$exists_at_least_one_presale_item = false;
		$cart = WC()->cart;			
		foreach($cart->cart_contents as $cart_item_key => $item)
		{
			/* wcps_var_dump($cart_item_key);
			wcps_var_dump($item); */
			
			$quantity = $wcps_cart_model->get_item_data($cart_item_key, 'quantity' ); //retrieve data from the _wcps_sesson data. If exists the product is in presale
			$is_deposit = $wcps_cart_model->get_item_data( $cart_item_key, 'is_deposit', false );
			
			//If not null, the item was a presale item
			if(isset($quantity))
			{
				$temp_id = $item['product_id'];
				if($item['variation_id'] != 0)
					$temp_id .="_".$item['variation_id'];
				
				//if(!in_array($temp_id, $product_ids))
					$product_ids[] = $temp_id;
				
				if(!isset($quantities[$item['product_id']]))
					$quantities[$item['product_id']] = 0;
				$quantities[$item['product_id']] += $quantity;
				//$product_is_deposit[$item['product_id']] = $is_deposit;
				$wcps_cart_model->remove_item_data($cart_item_key );
				
				//$coupon_all_products_ids = array();
				foreach($products as $order_item_id => $product)
				{
					if($item['product_id'] == $product['product_id'] && ($product['variation_id'] == 0 || $item['variation_id'] == $product['variation_id']) )
					{
						wc_add_order_item_meta( $order_item_id, '_wcps_presale', true );
						$exists_at_least_one_presale_item = true;
						
						//Deposit managment
						if($is_deposit)
						{
							$coupon = new WCPS_Coupon();
							$coupon_products_ids = array(); //array?
							/* if(isset($user_id) && $user_id > 0)
								$wcps_customer_model->update_deposit_meta_info($user_id, $item['product_id'], $item['variation_id'], $quantity); */
							
							/* if($item['variation_id'] != '')
							{
								$temp = new  WC_Product_Variable($product['product_id']);
								foreach($temp->get_available_variations() as $variation)
									if(!in_array($variation['variation_id'], $coupon_all_products_ids))
									{
										$coupon_products_ids[] = $variation['variation_id'];
										$coupon_all_products_ids[] = $variation['variation_id'];
									}
							}
							elseif(!in_array($variation['product_id'], $coupon_all_products_ids))
							{
								$coupon_all_products_ids = $product['product_id'];
								$coupon_products_ids[] = $product['product_id'] ;
							} */
							
							$coupon_products_ids[] = $item['variation_id'] != '' ? $item['variation_id'] : $item['product_id'];
							wc_add_order_item_meta( $order_item_id, '_wcps_is_deposit', true, true );
							//if(!empty($coupon_products_ids))
								$coupon_code = $coupon->create_coupon($order->billing_email, implode(",",$coupon_products_ids) , $item['line_subtotal'],$item['quantity']);
								wc_add_order_item_meta( $order_item_id, __('Deposit coupon code', 'woocommerce-pre-sale'),  $coupon_code, true);
								wc_add_order_item_meta( $order_item_id, '_wcps_coupon_code',  $coupon_code, true);
								wc_add_order_item_meta( $order_item_id, '_wpcs_coupon_id',  $coupon->get_id(), true);
						}
					}
				}
			}
			
		}
		foreach($quantities as $product_id => $total_quantity)
		{
			if(isset($user_id) && $user_id > 0)
				$wcps_customer_model->update_presale_meta_info($user_id,  $product_id, $total_quantity, true);
			$wcps_product_model->update_total_presales($product_id, $total_quantity);
		}
		$wcps_order_model->add_presale_meta_infos($order_id, $product_ids);
		
		/* if($exists_at_least_one_presale_item && $order_status_to_assign_after_checkout != 'leave_default')
		{
			//wcps_var_dump("here");
			$order->update_status($order_status_to_assign_after_checkout, '',true );
		} */
		//wc_add_notice( "debug", 'error' );
		//wp_die();
	}
	public function set_custom_order_status($order_id)
	{	
		global $wcps_option_model,$wcps_order_model;
		$order_status_to_assign_after_checkout = $wcps_option_model->get_option('order_status_to_assign_after_checkout');
		if($wcps_order_model->get_presales_items_still_active_num($order_id) && $order_status_to_assign_after_checkout != 'leave_default')
		{
			$order = new WC_Order($order_id);
			$order->update_status($order_status_to_assign_after_checkout);
		}
	}
	
}?>