<?php 
/*
Plugin Name: WooCommerce Pre-Sales / Time offers
Description: Pre sale / Time offer System for WooCommerce
Author: Lagudi Domenico
Version: 9.0
*/

//define('WCPS_PLUGIN_PATH', WP_PLUGIN_URL."/".dirname( plugin_basename( __FILE__ ) ) );
define('WCPS_PLUGIN_PATH', rtrim(plugin_dir_url(__FILE__), "/") ) ;
define('WCPS_PLUGIN_ABS_PATH', dirname( __FILE__ ) );

if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ||
     (is_multisite() && array_key_exists( 'woocommerce/woocommerce.php', get_site_option('active_sitewide_plugins') ))	
	)
{
	$wcps_id = 13335433;
	$wcps_name = "WooCommerce Pre-sale, Time offer & Expiring System";
	$wcps_activator_slug = "wcps-activator";
	/* if(!class_exists('WCPS_Presale'))
		require_once('classes/com/WCPS_Presale.php');
	$wcps_presale_model = new WCPS_Presale();	  */
	require_once('classes/com/WCPS_Globals.php');
	require_once('classes/admin/WCPS_ActivationPage.php');
	
	add_action('admin_menu', 'wcps_init_act');
	if(defined('DOING_AJAX') && DOING_AJAX)
			wcps_init_act();
	add_action('init', 'wcps_init');
	add_action('admin_notices', 'wcps_admin_notices' );
}

function wcps_register_settings()
{
	register_setting('wcps_options_group', 'wcps_options');
}
function wcps_init()
{
	load_plugin_textdomain('woocommerce-pre-sale', false, basename( dirname( __FILE__ ) ) . '/languages' );
	
	global $wcps_filters_manager;
	/* $wcps_presale_model->register_cpt(); */
	if(class_exists('WCPS_FiltersManager'))
		$wcps_filters_manager = new WCPS_FiltersManager();
	/* if(is_admin())
		wcps_init_act(); */
}
function wcps_admin_notices()
{
	global $wcps_notice, $wcps_name, $wcps_activator_slug;
	if($wcps_notice && (!isset($_GET['page']) || $_GET['page'] != $wcps_activator_slug))
	{
		 ?>
		<div class="notice notice-success">
			<p><?php echo sprintf(__( 'To complete the <span style="color:#96588a; font-weight:bold;">%s</span> plugin activation, you must verify your purchase license. Click <a href="%s">here</a> to verify it.', 'woocommerce-pre-sale' ), $wcps_name, get_admin_url()."admin.php?page=".$wcps_activator_slug); ?></p>
		</div>
		<?php
	}
}
function wcps_init_act()
{
	global $wcps_activator_slug, $wcps_name, $wcps_id;
	new WCPS_ActivationPage($wcps_activator_slug, $wcps_name, 'woocommerce-pre-sale', $wcps_id, WCPS_PLUGIN_PATH);
}
function wcps_setup()
{
	global $wcps_option_model, $wcps_product_model, $wcps_customer_model, $wcps_order_model, $wcps_html_helper, $wcps_cart_model, 
	$wcps_wpml_helper, $wcps_email_model, $wcps_order_details_admin_addon, $wcps_order_page_details_admin_addon, $wcps_filters_manager,
	$wcps_products_table, $wcps_orders_table, $wcps_options_page, $wcps_email_helper, $wcps_shortcodes;
	
	 if(!class_exists('WCPS_Coupon'))
		require_once('classes/com/WCPS_Coupon.php');
	
	if(!class_exists('WCPS_Tax'))
		require_once('classes/com/WCPS_Tax.php');
	
	if(!class_exists('WCPS_Option'))
		require_once('classes/com/WCPS_Option.php');
	$wcps_option_model = new WCPS_Option();
	
	 if(!class_exists('WCPS_Product'))
		require_once('classes/com/WCPS_Product.php');
	$wcps_product_model = new WCPS_Product();  ; 
	
	if(!class_exists('WCPS_Customer'))
		require_once('classes/com/WCPS_Customer.php');
	$wcps_customer_model = new WCPS_Customer();  
	
	if(!class_exists('WCPS_Order'))
		require_once('classes/com/WCPS_Order.php');
	$wcps_order_model = new WCPS_Order();  
	
	if(!class_exists('WCPS_Html'))
		require_once('classes/com/WCPS_Html.php');
	$wcps_html_helper = new WCPS_Html(); 
	
	if(!class_exists('WCPS_Cart'))
		require_once('classes/com/WCPS_Cart.php');
	$wcps_cart_model = new WCPS_Cart();  
	
	if(!class_exists('WCPS_Wpml'))
		require_once('classes/com/WCPS_Wpml.php');
	$wcps_wpml_helper = new WCPS_Wpml(); 
	
	if(!class_exists('WCPS_Email'))
		require_once('classes/com/WCPS_Email.php');
	$wcps_email_model = new WCPS_Email();
	
	if(!class_exists('WCPS_ProductDetails'))
		require_once('classes/admin/WCPS_ProductDetails.php');
	$wcps_order_details_admin_addon = new WCPS_ProductDetails();
	
	if(!class_exists('WCPS_OrderDetailsPage'))
		require_once('classes/admin/WCPS_OrderDetailsPage.php');
	$wcps_order_page_details_admin_addon = new WCPS_OrderDetailsPage();
	
	if(!class_exists('WCPS_FiltersManager'))
		require_once('classes/frontend/WCPS_FiltersManager.php');
	
	if(!class_exists('WCPS_ProductsTable.php'))
		require_once('classes/admin/WCPS_ProductsTable.php');
	$wcps_products_table = new WCPS_ProductsTable();
	
	if(!class_exists('WCPS_OrdersTable.php'))
		require_once('classes/admin/WCPS_OrdersTable.php');
	$wcps_orders_table = new WCPS_OrdersTable();
	
	if(!class_exists('WCPS_OptionsMenu'))
		require_once('classes/admin/WCPS_OptionsMenu.php');
	$wcps_options_page = new WCPS_OptionsMenu();
	
	if(!class_exists('WCPS_Email'))
		require_once('classes/com/WCPS_Email.php');
	$wcps_email_helper = new WCPS_Email();
	
	//include WCPS_PLUGIN_ABS_PATH."/classes/com/WCPS_Globals.php";
	
	if(!class_exists('WCPS_Shortcodes'))
		require_once('classes/com/WCPS_Shortcodes.php');
	$wcps_shortcodes = new WCPS_Shortcodes();
	
	add_action('admin_init', 'wcps_register_settings');
	add_action('admin_menu', 'wcps_init_admin_panel');
}
function wcps_init_admin_panel()
{ 
	$place = wcps_get_free_menu_position(57 , .1);
	add_menu_page( __('Pre-sales / Time offers', 'woocommerce-pre-sale'), __('Pre-sales / Time offers', 'woocommerce-pre-sale'), 'manage_woocommerce', 'wcps-pre-sale', 'wcps_load_bulk_editor_page', 'dashicons-tag', (string)$place);
	add_submenu_page('wcps-pre-sale',  __('Orders/Coupons finder', 'woocommerce-pre-sale'), __('Orders finder', 'woocommerce-pre-sale'), 'manage_woocommerce', 'woocommerce-pre-sale-orders-finder', 'wcps_load_orders_finder_page');
	//add_submenu_page('wcps-pre-sale', __('Bulk edit', 'woocommerce-pre-sale'), __('Bulk edit', 'woocommerce-pre-sale'), 'manage_woocommerce', 'woocommerce-pre-sale-configurator', 'wcps_load_bulk_editor_page');
	add_submenu_page('wcps-pre-sale', __('Options','woocommerce-pre-sale'), __('Options','woocommerce-pre-sale'), 'manage_woocommerce', 'wcps-options-page', 'wcps_load_option_page');
	//add_menu_page('woocommerce',  __('Presale', 'woocommerce-pre-sale'), __('Presale', 'woocommerce-pre-sale'), 'manage_woocommerce', 'woocommerce-pre-sale-items-list', 'wcps_load_ites_list_view'
	
}
function wcps_load_orders_finder_page()
{
	if(!class_exists('WCPS_Finder'))
		require_once('classes/admin/WCPS_Finder.php');
	$orders_finder = new WCPS_Finder();
	$orders_finder->render_page();
}
function wcps_get_free_menu_position($start, $increment = 0.3)
{
	foreach ($GLOBALS['menu'] as $key => $menu) {
		$menus_positions[] = $key;
	}

	if (!in_array($start, $menus_positions)) return $start;

	/* the position is already reserved find the closet one */
	while (in_array($start, $menus_positions)) {
		$start += $increment;
	}
	return $start;
}
function wcps_load_option_page()
{
	global $wcps_options_page;
	$wcps_options_page->render_page();
}
function wcps_load_bulk_editor_page()
{
	if(!class_exists('WCPS_BulkEditor'))
		require_once('classes/admin/WCPS_BulkEditor.php');
	$bulk_editor = new WCPS_BulkEditor();
	$bulk_editor->render_page();
}
function wcps_var_dump($var)
{
	echo "<pre>";
	var_dump($var);
	echo "</pre>";
}
?>